<?xml version="1.0" encoding="windows-1250"?>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
                version="1.0">

<xsl:import href=$$IMPORTED_XSLT$$/>
    <!-- Import the set of templates we are modifying. 
         This will be processed by DocGen. -->

<!-- XSL parameters modification... -->

<!-- Paper size -->
<xsl:param name="paper.type" select="'A4'"/>

<!-- Extensions for callouts, etc. -->
<!--<xsl:param name="use.extensions" select="1"/>-->
    <!-- Note: The previous line yields error in Saxon, currently. -->

<!-- FO procesor specific extensions -->
<!--<xsl:param name="passivetex.extensions" select="1"/>-->
<!--<xsl:param name="xep.extensions" select="1"/>-->

<!-- This extension, besides others, tells FOP to generate the 
     quick contents window on the left side of the PDF document. -->
<xsl:param name="fop.extensions" select="1"/>

<!-- Font -->
<xsl:param name="body.font.master">11</xsl:param>

<!-- Margin sizes -->
<xsl:param name="page.margin.inner" select="'1in'"/>
<xsl:param name="page.margin.outer" select="'1in'"/>

<!-- Section and chapter numbering -->
<xsl:param name="section.autolabel" select="1"/>
<xsl:param name="section.label.includes.component.label" select="1"/>
<xsl:param name="chapter.autolabel" select="1"/>
<xsl:param name="appendix.autolabel" select="1"/>
<xsl:param name="part.autolabel" select="1"/>
<xsl:param name="preface.autolabel" select="0"/>

<!-- Align titles with text. -->
<xsl:param name="title.margin.left" select="'0pt'"/>

<!-- Use graphics for callouts and notes/warnings -->
<!-- Note: use gifs, because FOP needs extra libs for png support -->
<xsl:param name="callout.extension" select="'1'"/>
<xsl:param name="callout.graphics" select="'0'"/>
<xsl:param name="callout.unicode" select="'1'"/>

<xsl:param name="admon.graphics" select="'0'"/>
<xsl:param name="admon.graphics.extension" select="'.gif'"/>

<!-- Notes/warnings margin -->
<!--
<xsl:param name="admon.style">
  <xsl:text>margin-left: 0.5in; margin-right: 0.5in;</xsl:text>
  </xsl:param>
-->

<!-- Function synopsis in ansi style -->
<xsl:param name="funcsynopsis.style" select="'ansi'"/>

<!-- Removed the 'Chapter' substring to shorten chapter titles and
     increase a chance they can fit each into a single line. -->
<xsl:param name="local.l10n.xml" select="document('')"/> 
<l:i18n xmlns:l="http://docbook.sourceforge.net/xmlns/l10n/1.0"> 
  <l:l10n language="en"> 
    <l:context name="title-numbered"> 
      <l:template name="chapter" text="%n.&#160;%t"/>
    </l:context>    
  </l:l10n>
</l:i18n>

<!-- Do not download the image from Internet. -->
<xsl:param name="draft.watermark.image" select="'none.png'"/>

<!-- XSL templates modification... -->
<xsl:include href="templates/fo.xsl"/>

</xsl:stylesheet>
