<?php
require_once( "massiv.php" );
html_begin( "Downloads" );
?>

<h3> <?php draw_dot(); ?> Downloads </h3>

<h5> Latest Stable Release (1.1c) (Sep 5 2008) </h5>

<p>
This version contains maintenance updates to the codebase that have accumulated
in the SVN trunk since 1.1b. These updates make sure that the project can be 
compiled cleanly with newer versions of popular C++ compilers and that the most
recent version of CryptoPP (version 5.5.2 at the time of writing) can be used. 
The project has been verified to build and run successfuly with GCC 3.4 and 
GCC 4.3 as well as MSVC 7.1, 8 and 9. No installers are provided for 1.1c 
because no functional changes were made to the Demo. If you want to see the
Demo, download the 1.1 version. The updated 1.1c sources can be downloaded
directly from
<a href="http://forge.objectweb.org/project/showfiles.php?group_id=149">ObjectWeb Forge</a>.
</p>

<h5> Version 1.1b (Oct 11 2004) </h5>

<p>
This is a version 1.1 licensed under LGPL. Since there were no changes in
the functionality of both the core library and the Demo since 1.1 we did not
make installers for this version. If you want to see the Demo, download the
1.1 version. The new 1.1b sources can be downloaded directly from
<a href="http://forge.objectweb.org/project/showfiles.php?group_id=149">ObjectWeb Forge</a>.
</p>

<h5> Version 1.1 (Jun 30 2004) </h5>

<p>
Version 1.1 is the first official release of the Massiv and an exemplary
application, "the Demo". The Demo can be downloaded from
<a href="http://forge.objectweb.org/project/showfiles.php?group_id=149">ObjectWeb Forge</a>
as a set of Win32 installers. The first one deploys the simulation to selected
<a href="http://forge.objectweb.org/project/showfiles.php?group_id=149">servers</a>,
the other installs individual
<a href="http://forge.objectweb.org/project/showfiles.php?group_id=149">clients</a>.
</p>

<p>
Since there are still no official servers on the Internet that clients can
connect to, you will have to setup your own server(s) first. Please follow
the installation wizard and/or consult the documention
(<a href="http://forge.objectweb.org/project/showfiles.php?group_id=149">user guide</a>,
unfortunatelly in Czech).
</p>

<p>
You can build the Demo yourself from the sources as well (and this is the
only way how to deploy the simulation to Unix servers). In that case you will
need the <a href="http://forge.objectweb.org/project/showfiles.php?group_id=149">core library and the demo sources</a>,
<a href="http://forge.objectweb.org/project/showfiles.php?group_id=149">the Demo application data</a>
and optionally <a href="http://forge.objectweb.org/project/showfiles.php?group_id=149">initial archives</a>
holding the state of the precreated exemplary "world". Note that the archives
need not be downloaded separately if the simulation is deployed using the Win32
installer. The actual build procedure is the same as if the sources were
downloaded directly from the SVN.
</p>

<h5> Building the Demo from the SVN repository </h5>

<p>
The SVN repository consists of three modules:
</p>

<ul>
    <li>
    <i>massiv</i> (sources of the Core library and the Demo, documentation)
    </li>

    <li>
    <i>demo_data</i> (data for the Demo)
    </li>

    <li>
    <i>demo_install</i> (Win32 installers and initial archives).
    </li>
</ul>

<p>
In order to build and run the Demo you will have to checkout
both the massiv and demo_data. Consult the
<a href="http://forge.objectweb.org/project/showfiles.php?group_id=149">programmer's guide</a>,
chapter Compilation, to get exact build instructions. To replace the initial
archives created by the builder tool and use the precreated "factory" world,
simply unpack <i>demo_install/win32/simulation/server/archive/archive.zip</i>
to the archive directories of the installed server(s).
</p>

<h5> Documentation and Presentation </h5>

<p>
There is a separate
<a href="http://forge.objectweb.org/project/showfiles.php?group_id=149">package</a>
containing the documentation of the Core library and the Demo, the introductory
presentation, simple user's guide for the Demo and doxygen-generated reference
guides.
</p>

<?php html_end(); ?>
