/** @file makedir.c
 * Creates directory. 
 * In contrast to standard mkdir allows directory name to be terminated by backslash.
 * Usage: makedir path
 */

/*
 * begin        : Fri Dec 14 2001
 * copyright    : (C) 2001 by Petr Tovarys
 */

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it according to instructions in massiv/doc/licenses/source.txt.       *
 *                                                                         *
 ***************************************************************************/


#include <stdio.h>
#include <direct.h>
#include <string.h>


int main
    (
    int     argc,
    char *  argv[]
    )
    {
    int len;

    if( argc != 2 )
        {
        fprintf( stderr, "Invalid arguments count.\n" );
        printf( "Usage: makedir path\n" );
        return 1;
        }

    for( len = strlen( argv[1] ) - 1; len >= 0 && ( argv[1][len] == '\\' || argv[1][len] == '/' ); len-- )
        {
        argv[1][len] = '\0';
        }

    for( len = 0; len <= strlen( argv[1] ); len++ )
        {
        if( argv[1][len] == '\0' || argv[1][len] == '/' || argv[1][len] == '\\' )
            {
            char c;
            c = argv[1][len];
            argv[1][len] = '\0';
            /*if( mkdir( argv[1] ) != 0 )
                {
                fprintf( stderr, "Unable to create directory.\n" );
                return 1;
                }*/
            mkdir( argv[1] );
            argv[1][len] = c;
            }
        }

    return 0;
    }
