/** @file makedir.c
 * Dumbed down touch.
 * Usage: touch file
 * Creates file or changes its modification time to current time.
 */

/*
 * begin        : Fri Mar 14 2002
 * copyright    : (C) 2002 by Stepan Vondrak
 */

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it according to instructions in massiv/doc/licenses/source.txt.       *
 *                                                                         *
 ***************************************************************************/


#include <sys/types.h>
#include <sys/utime.h>
#include <io.h>
#include <stdio.h>

#ifndef F_OK
#define F_OK        0x00
#endif // F_OK


int main
    (
    int     argc,
    char *  argv[]
    )
    {
    int len;

    if( argc != 2 )
        {
        fprintf( stderr, "Invalid arguments count.\n" );
        printf( "Usage: touch file\n" );
        return 1;
        }

    if( access( argv[ 1 ], F_OK ) )
        {
        // File does not exist - create it
        FILE * f;
        f  = fopen( argv[ 1 ], "w" );
        if( !f )
            {
            fprintf( stderr, "Can't create '%s'.\n", argv[ 1 ] );
            return 1;
            }
        fclose( f );
        }
    else
        {
        if( utime( argv[ 1 ], NULL ) )
            {
            fprintf( stderr, "Can't utime '%s'.\n", argv[ 1 ] );
            return 1;
            }
        }

    return 0;
    }
