/** @file core.h
 * Massiv core public interface.
 * Exposes core classes, object model, etc.
 */

/*
 * begin        : Tue Apr 23 2002
 * copyright    : (C) 2002 by Marek Vondrak
 */

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it according to instructions in massiv/doc/licenses/source.txt.       *
 *                                                                         *
 ***************************************************************************/

#ifndef MASSIV_CORE_H
#define MASSIV_CORE_H

// Basic services.

#ifndef MASSIV_CORE_BASE_H
#include "core_base.h"
#endif


// Properties.

#ifndef MASSIV_PROPERTIES_H
#include "property/properties.h"
#endif


// Light-weight serializable types.

#ifndef MASSIC_STYPES_H
#include "serializer/stypes.h"
#endif


// Objects.

#ifndef MASSIV_OBJECT_H
#include "object/object.h"
#endif

#ifndef MASSIV_VALUE_TYPE_H
#include "object/value_type.h"
#endif

#ifndef MASSIV_THROWABLE_H
#include "object/throwable.h"
#endif

#ifndef MASSIV_OBJECT_CREATE_H
#include "object/object_create.h"
#endif


// Pointers.

#ifndef MASSIV_OBJECT_POINTER_H
#include "pointer/object_pointer.h"
#endif

#ifndef MASSIV_POINTER_TO_OBJECT_H
#include "pointer/pointer_to_object.h"
#endif


// Special objects.

#ifndef MASSIV_RPC_H
#include "object/rpc.h"
#endif


// Lib classes and interfaces predefined by the core.

#ifndef MASSIV_NODE_OBJECT_INTERFACE_H
#include "object/lib/node_object_interface.h"
#endif

#ifndef MASSIV_ACCOUNT_OBJECT_INTERFACE_H
#include "object/lib/account_object_interface.h"
#endif

#ifndef MASSIV_LIB_EXCEPTIONS_H
#include "object/lib/lib_exceptions.h"
#endif


#endif // MASSIV_CORE_H
