/** @file core_management.h
 * Massiv core public interface.
 * Exposes core internal classes that are used to manage & debug the system.
 */

/*
 * begin        : Wed Mar 21 2003
 * copyright    : (C) 2003 by Marek Vondrak
 */

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it according to instructions in massiv/doc/licenses/source.txt.       *
 *                                                                         *
 ***************************************************************************/

#ifndef MASSIV_CORE_MANAGEMENT_H
#define MASSIV_CORE_MANAGEMENT_H

#ifndef MASSIV_CORE_H
#error "Include core.h first!"
#endif


// Registry.

#ifndef MASSIV_REGISTRY_H
#include "registry/registry.h"
#endif


// Logger.

#ifndef MASSIV_LOGGER_H
#include "logger/logger.h"
#endif

#ifndef MASSIV_LOGGER_CLIENTS_H
#include "logger/logdest_clients.h"
#endif


// Object management.

#ifndef MASSIV_OBJECT_MANAGER_H
#include "object/object_manager.h"
#endif

#ifndef MASSIV_GARBAGE_COLLECTOR_H
#include "pointer/garbage_collector.h"
#endif

#ifndef MASSIV_REPLICA_SERVER_H
#include "replication/replica_server.h"
#endif

#ifndef MASSIV_REPLICA_CLIENT_H
#include "replication/replica_client.h"
#endif


// Archive management.

#ifndef MASSIV_ARCHIVE_MANAGER_H
#include "object/archive_manager.h"
#endif


// Data management.

#ifndef MASSIV_DATA_MANAGER_H
#include "data/data_manager.h"
#endif

#ifndef MASSIV_PATH_MANAGER_H
#include "data/path_manager.h"
#endif


// Miscellaneous.

#ifndef MASSIV_WILDCARDS_H
#include "utility/wildcards.h"
#endif

#ifndef MASSIV_QUOTE_STRING_H
#include "utility/quote_string.h"
#endif


#endif // MASSIV_CORE_MANAGEMENT_H
