/** @file well_known_object_id_database.cpp
 * Database of well known object ids (implementation).
 */

/*
 * begin        : Sun Oct 12 2003
 * copyright    : (C) 2003 by Petr Tovarys
 */

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it according to instructions in massiv/doc/licenses/source.txt.       *
 *                                                                         *
 ***************************************************************************/

#include "database/well_known_object_id_database.h"
#include "serializer/serializer.h"
#include "utility/text_reader.h"
#include <sstream>


namespace Massiv {
namespace Core {


// WellKnownObjectIdDatabase::WellKnownObjectIdDatabaseSettings
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~


WellKnownObjectIdDatabase::WellKnownObjectIdDatabaseSettings::WellKnownObjectIdDatabaseSettings() :
    Settings( "WellKnownObjectIdDatabase" ),
    naming_service_object( access_string( "naming_service_object", "[ null ]" ) )
    {
    }


// WellKnownObjectIdDatabase::WellKnownObjectIdDatabase
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~


WellKnownObjectIdDatabase::WellKnownObjectIdDatabase()
    {
    }
    
    
ObjectId WellKnownObjectIdDatabase::get_naming_service_object()
    {
    ObjectId naming_service_object_id;
    
    // Extract object id.
        {
        std::istringstream iss( settings.naming_service_object );
        TextReader tr( iss );
        tr.next_line();
        naming_service_object_id.text_read( tr, Serializer::Description() );
        }
    
    return naming_service_object_id;
    }


} // namespace Core
} // namespace Massiv
