=head1 NAME

IdlParserFile - parsing of file scope-related stuff of C<IdlParser>.

=cut

package IdlParser ;


###
# _parse_include_header
sub _parse_include_header {
    my $self = shift ;

    # Skip 'include_header'.
    
    $self->consume_token( 'include_header' ) ;

    # Read header name.

    $self->ensure_string() ;
    my $header_name = $self->token_value() ;
    $self->next_token() ;
    $self->consume_token( ';' ) ;

    # Add header to list of headers.

    my $idl_infos = $$self{ IDL_INFOS } ;
    my $idl_name = $self->file_name() ;
    my $idl_info = $$idl_infos{ $idl_name } ;
    unless ( defined( $idl_info ) ) {
        $idl_info = {
            HEADERS => [ ],
        } ;
        $$idl_infos{ $idl_name } = $idl_info ;
    }
    push( @{$$idl_info{ HEADERS }}, $header_name ) ;
}


1 ;


__END__
