#! /usr/bin/perl -w

use strict ;
use warnings ;

use FindBin ;
use lib "$FindBin::Bin/../lib" ;
use Parser ;


my $file_name = $ARGV[ 0 ] || 'test.txt' ;
my $parser = Parser->new ;
$parser->push_file( $file_name ) ;

# Parser the file.

for ( ; ; ) {
    $parser->next_token() ;
    my $token = $parser->token() ;
    unless ( defined( $token ) ) {
        last ;
    }

    my $file = $parser->file_name() ;
    my $line = $parser->line_number() ;
    my $token_string = $token->token() ;
    my $token_value = $token->value() ;
    my $token_type = $token->type() ;

    print "$file ($line): $token_string is '$token_type', value '$token_value'.\n" ;
}
