/** @file common_gcc.h
 * Common GNU C/C++ compiler stuff.
 */

/*
 * begin        : 2002
 * copyright    : (C) 2002 by Stepan Vondrak
 */

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it according to instructions in massiv/doc/licenses/source.txt.       *
 *                                                                         *
 ***************************************************************************/


#ifndef MASSIV_COMMON_GCC_H
#define MASSIV_COMMON_GCC_H


#include <cassert>


namespace Massiv {
namespace Core {


#if ( __GNUC__ < 3 && __GNUC_MINOR__ < 97 ) && !defined( OPTION_STLPORT )
#error "STLPort must be used when compiling by pre-2.97 gcc, libstdc++2 is not good enough."
#endif // gcc version

#define NORETURN( Type ) Type __attribute__(( __noreturn__ ))

#ifdef __ASSERT_FUNCTION
#define CURRENT_FUNCTION_NAME __ASSERT_FUNCTION
#endif


} // namespace Massiv::Core
} // namespace Massiv


#endif // MASSIV_COMMON_GCC_H
