/** @file common_unix.h
 * Common UN*X stuff.
 *
 * @todo Check system and define constant such as "using glibc extensions" etc.
 *       Currently many unix-specific files contain
@code
#ifdef SYSTEM_LINUX
...
#else
#error "not implemented"
#endif
@endcode
        while <tt>\#ifdef USING_GLIBC</tt> or something simular would be proper.
 */

/*
 * begin        : 2002
 * copyright    : (C) 2002 by Stepan Vondrak
 */

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it according to instructions in massiv/doc/licenses/source.txt.       *
 *                                                                         *
 ***************************************************************************/


#ifndef MASSIV_COMMON_UNIX_H
#define MASSIV_COMMON_UNIX_H


#if defined( COMPILER_GCC )
#include "global/common_gcc.h"

#elif defined( COMPILER_ICC )
#include "global/common_icc.h"

#else
#error "Unsupported UN*X compiler."
#endif


#endif // MASSIV_COMMON_UNIX_H
