/** @file logdest_cerr.cpp
 * Console error output log destination.
 * @see logdest_cerr.h
 */

/*
 * begin        : Thu Mar 06 2003
 * copyright    : (C) 2003 by Marek Svantner
 */

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it according to instructions in massiv/doc/licenses/source.txt.       *
 *                                                                         *
 ***************************************************************************/

#include "logger/logdest_cerr.h"
#include <iostream>


namespace Massiv {
namespace Core {
    

LogDestinationCerr::LogDestinationCerr()
    {
    }


LogDestinationCerr::~LogDestinationCerr()
    {
    LogDestinationCerr::flush_hard();
    }


std::string LogDestinationCerr::get_name() const
    {
    return "cerr";
    }


std::string LogDestinationCerr::get_description() const
    {
    return "Console error output.";
    }


bool LogDestinationCerr::match_name
    (
    const std::string & name
    )
    {
    return name == "cerr";
    }


void LogDestinationCerr::log
    (
    const std::string & ,
    const LogMessage &  message
    )
    {
    std::cerr << message.get_string() << '\n';
    }


void LogDestinationCerr::flush()
    {
    flush_hard();
    }


void LogDestinationCerr::flush_hard()
    {
    std::cerr.flush();
    }


} // namespace Massiv::Core
} // namespace Massiv
