/** @file logdest_cout.cpp
 * Console output log destination.
 * @see logdest_cout.h
 */

/*
 * begin        : Tue Nov 25 2001
 * copyright    : (C) 2001 by Stepan Vondrak
 */

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it according to instructions in massiv/doc/licenses/source.txt.       *
 *                                                                         *
 ***************************************************************************/

#include "logger/logdest_cout.h"
#include <iostream>


namespace Massiv {
namespace Core {


LogDestinationCout::LogDestinationCout()
    {
    }


LogDestinationCout::~LogDestinationCout()
    {
    LogDestinationCout::flush_hard();
    }


std::string LogDestinationCout::get_name() const
    {
    return "cout";
    }


std::string LogDestinationCout::get_description() const
    {
    return "Console output.";
    }


bool LogDestinationCout::match_name
    (
    const std::string & name
    )
    {
    return name == "cout";
    }


void LogDestinationCout::log
    (
    const std::string & ,
    const LogMessage &  message
    )
    {
    std::cout << message.get_string() << '\n';
    }


void LogDestinationCout::flush()
    {
    flush_hard();
    }


void LogDestinationCout::flush_hard()
    {
    std::cout.flush();
    }


} // namespace Massiv::Core
} // namespace Massiv
