/** @file bitiostream_common.h
 * Common data types for bit-oriented i/o streams.
 */

/*
 * begin        : Sun Apr 14 2002
 * copyright    : (C) 2002 by Petr Tovarys
 */

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it according to instructions in massiv/doc/licenses/source.txt.       *
 *                                                                         *
 ***************************************************************************/

#ifndef MASSIV_BITIOSTREAM_COMMON_H
#define MASSIV_BITIOSTREAM_COMMON_H


#ifndef MASSIV_COMMON_H
#include "global/common.h"
#endif

#ifndef MASSIV_ARRAY_H
#include "utility/array.h"
#endif

#ifndef MASSIV_TYPES_H
#include "utility/types.h"
#endif


namespace Massiv {
namespace Core {


/**
 * @typedef BitIOStreamBuffer
 * Shared array used as bit stream input/output buffer.
 *
 * @ingroup utility
 * @ingroup net
 */
typedef NormalizedArray< SharedStorage< DynamicStorage< UInt8 > > > BitIOStreamBuffer;


/**
 * @class BitIOStream
 * Abstract base class for BitIStream and BitOStream classes.
 *
 * @ingroup utility
 * @ingroup net
 */
class BitIOStream
    {
public:

    enum SeekWhence
        {
        WHENCE_START,
        WHENCE_CURRENT,
        WHENCE_END
        };

public:

    /**
     */
    BitIOStream()
        {
        }

    /**
     */
    ~BitIOStream()
        {
        }

    };  // class BitIOStream


} //namespace Massiv::Core
} //namespace Massiv


#endif // MASSIV_BITIOSTREAM_COMMON_H
