/** @file bitostream_inline.h
 * Bit-oriented output stream buffer.
 */

/*
 * begin        : Tue Nov 9 2001
 * copyright    : (C) 2001 by Ondrej Pecta, Stepan Vondrak
 */

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it according to instructions in massiv/doc/licenses/source.txt.       *
 *                                                                         *
 ***************************************************************************/

#ifndef MASSIV_BITOSTREAM_H
#include "net/bitostream.h"
#endif



namespace Massiv {
namespace Core {


BitOStream::BitOStream()
    {
    reset();
    }


BitOStream::BitOStream
    (
    int size
    )
    {
    reset( size );
    }


BitOStream::~BitOStream()
    {
    }


BitIOStreamBuffer BitOStream::unbind()
    {
    BitIOStreamBuffer buf;
    buf.reserve( DEFAULT_STRBUF_SIZE );
    return bind( buf, false );
    }


BitIOStreamBuffer BitOStream::reset
    (
    int size
    )
    {
    BitIOStreamBuffer buf;
    buf.reserve( size );
    return bind( buf, false );
    }


BitIOStreamBuffer BitOStream::reset()
    {
    return unbind();
    }

    
BitIOStreamBuffer BitOStream::get_buffer()
    {
    return buffer;
    }


void BitOStream::align_to_byte()
    {
    if( bit > 0 )
        {
        write_int( 0, 8 - bit );
        hope( !bit );
        }
    }


int BitOStream::bit_size() const
    {
    return num_bits;
    }


int BitOStream::byte_size() const
    {
    return buffer.size();
    }


} //namespace Massiv::Core
} //namespace Massiv
