/** @file massiv_blowfish.cpp
 * Blowfish cipher.
 */

/*
 * begin        : Tue Nov 9 2001
 * copyright    : (C) 2001 by Ondrej Pecta
 */

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it according to instructions in massiv/doc/licenses/source.txt.       *
 *                                                                         *
 ***************************************************************************/

#include "net/massiv_blowfish.h"

namespace Massiv {
namespace Core {


template <class Engine>
BlowfishCipher<Engine>::BlowfishCipher
    (
    const Key & key
    ) : engine( reinterpret_cast<const UInt8 *>( key.c_str() ), key.size() )
    {
    }


template <class Engine>
void BlowfishCipher<Engine>::process_block
    (
    const UInt8 *   input,
    UInt8 *         output
    )
    {
    engine.ProcessBlock( input, output );
    }


/* Instantiate the templates. */

template class MASSIV_EXPORTED BlowfishCipher<CryptoPP::BlowfishEncryption>;
template class MASSIV_EXPORTED BlowfishCipher<CryptoPP::BlowfishDecryption>;

} // namespace Massiv::Core
} // namespace Massiv
