/** @file netibuffer.cpp
 * Bit-oriented network input stream with ability of decrypting messages.
 */

/*
 * begin        : Tue Apr 23 2002
 * copyright    : (C) 2002 by Ondrej Pecta
 */

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it according to instructions in massiv/doc/licenses/source.txt.       *
 *                                                                         *
 ***************************************************************************/

#include "net/netibuffer.h"
#include "net/massiv_checksum_impl.h"

namespace Massiv {
namespace Core {


NetIBuffer::NetIBuffer() : engine_checksum( &buffer )
    {
    }


NetIBuffer::NetIBuffer
    (
    const NetIBuffer &      sourcebuf
    ) : BitIStream( sourcebuf ),
        engine_checksum( sourcebuf.engine_checksum ),
        tag( sourcebuf.tag )
    {
    engine_checksum.set_buffer( &buffer );
    }


NetIBuffer::~NetIBuffer()
    {
    }


} // namespace Massiv::Core
} // namespace Massiv
