/** @file node_action.cpp
 * Node actions (implementation).
 */

/*
 * begin        : Sat Oct 4 2003
 * copyright    : (C) 2003 by Petr Tovarys
 */

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it according to instructions in massiv/doc/licenses/source.txt.       *
 *                                                                         *
 ***************************************************************************/

#include "node/node_action.h"
#include "node/node_action_server_quit.h"
#include "node/node_action_startup.h"
#include "utility/debug.h"
#include <cstddef>


namespace Massiv {
namespace Core {


// NodeAction
//~~~~~~~~~~~


NodeAction::NodeAction()
    {
    }


NodeAction::~NodeAction()
    {
    }


NodeAction * NodeAction::create
    (
    Id action_id
    )
    {
    switch( action_id )
        {
        case NONE:
        case COUNT:
            panic( "Invalid node action id." );
            break;
        
        case SERVER_QUIT:
            return new NodeActionServerQuit();
        
        case STARTUP:
            return new NodeActionStartup();
        }

    panic( "Invalid node action id." );
    return NULL; // Never reached.
    }


} // namespace Massiv::Core
} // namespace Massiv
