/** @file node_action_id_inline.h
 * Node action id (inline methods).
 */

/*
 * begin        : Sat Oct 4 2003
 * copyright    : (C) 2003 by Petr Tovarys
 */

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it according to instructions in massiv/doc/licenses/source.txt.       *
 *                                                                         *
 ***************************************************************************/

namespace Massiv {
namespace Core {


// NodeActionId::Hash


size_t NodeActionId::Hash::operator()
    (
    const NodeActionId & action_id
    ) const throw()
    {
    NodeAction::Id v = action_id.get();
    return v;
    }


// NodeActionId::EqualKey


bool NodeActionId::EqualKey::operator()
    (
    const NodeActionId & action_id1,
    const NodeActionId & action_id2
    ) const throw()
    {
    return action_id1.get() == action_id2.get();
    }


// NodeActionId


NodeActionId::NodeActionId() :
    id( NodeAction::NONE )
    {
    }


NodeActionId::NodeActionId( const NodeActionId & other ) :
    id( other.id )
    {
    }


NodeActionId::NodeActionId( NodeAction::Id the_id ) :
    id( the_id )
    {
    }


NodeActionId::~NodeActionId()
    {
    }


NodeActionId & NodeActionId::operator=( const NodeActionId & other )
    {
    return set( other.get() );
    }


void NodeActionId::bitstr_write
    (
    BitOStream &                        bos,
    const Serializer::Description &     desc
    ) const
    {
    id.bitstr_write( bos, desc );
    }

void NodeActionId::bitstr_read
    (
    BitIStream &                        bis,
    const Serializer::Description &     desc
    )
    {
    id.bitstr_read( bis, desc );
    }


NodeAction::Id NodeActionId::get() const
    {
    return id;
    }


NodeActionId & NodeActionId::set( NodeAction::Id the_id )
    {
    id = the_id;
    return *this;
    }


} // namespace Massiv::Core
} // namespace Massiv
