/** @file node_action_state.cpp
 * Node action state structure (implementation).
 */

/*
 * begin        : Sat Oct 4 2003
 * copyright    : (C) 2003 by Petr Tovarys
 */

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it according to instructions in massiv/doc/licenses/source.txt.       *
 *                                                                         *
 ***************************************************************************/

#include "node/node_action_state.h"
#include "node/node_action.h" // ~NodeAction()
#include <cstddef>


namespace Massiv {
namespace Core {


NodeActionState::NodeActionState() :
    phase( PHASE_NONE ),
    num_replies( 0 ),
    num_awaiting_replies( 0 ),
    node_action_object( NULL )
    {
    }


NodeActionState::NodeActionState
    (
    const NodeActionState & other
    ) :
    phase( other.phase ),
    num_replies( other.num_replies ),
    num_awaiting_replies( other.num_awaiting_replies ),
    node_action_object( other.node_action_object )
    {
    }


NodeActionState::~NodeActionState()
    {
    delete node_action_object;
    node_action_object = NULL;
    }


NodeActionState & NodeActionState::operator=
    (
    const NodeActionState & other
    )
    {
    phase = other.phase;
    num_replies = other.num_replies;
    num_awaiting_replies = other.num_awaiting_replies;
    node_action_object = other.node_action_object;
    other.node_action_object = NULL;
    return *this;
    }


} // namespace Massiv::Core
} // namespace Massiv
