/** @file node_manager_anonymous.cpp
 * Anonymous specialization of NodeManager::Node.
 */
 
/*
 * begin        : Sat Nov 8 2003
 * copyright    : (C) 2003 by Petr Tovarys
 */

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it according to instructions in massiv/doc/licenses/source.txt.       *
 *                                                                         *
 ***************************************************************************/

#include "node/node_manager_anonymous.h"
#include "global/global.h"
#include "global/global_callbacks.h"
#include "utility/debug.h"
#include "sysevent/simulation_sync_msg.h"
#include "sysevent/client_connection_msg.h"
#include "sysevent/system_msg.h"
#include "time/time_manager.h"
#include "database/node_database.h"
#include "net/net.h"


namespace Massiv {
namespace Core {


NodeManager::Anonymous::Anonymous()
    {
    }


void NodeManager::Anonymous::connect()
    {
    panic( "Anonymous node can't connect()." );
    }


bool NodeManager::Anonymous::is_connected()
    {
    return false;
    }


void NodeManager::Anonymous::disconnect()
    {
    }


void NodeManager::Anonymous::next_tick()
    {
    }


} // namespace Massiv::Core
} // namespace Massiv
