/** @file node_manager_settings.h
 * Node manager settings.
 */
 
/*
 * begin        : Sat Nov 8 2003
 * copyright    : (C) 2003 by Petr Tovarys
 */

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it according to instructions in massiv/doc/licenses/source.txt.       *
 *                                                                         *
 ***************************************************************************/

#ifndef MASSIV_NODE_MANAGER_SETTINGS_H
#define MASSIV_NODE_MANAGER_SETTINGS_H


#ifndef MASSIV_COMMON_H
#include "global/common.h"
#endif

#ifndef MASSIV_NODE_MANAGER_H
#include "node/node_manager.h"
#endif

#ifndef MASSIV_STATISTICS_H
#include "registry/statistics.h"
#endif


namespace Massiv {
namespace Core {


/** @addtogroup node
 * @{
 */

/**
 * Node manager settings.
 */
class NodeManager::NodeManagerSettings : public Settings
    {
public:

    /** Constructor. */
    NodeManagerSettings();

public:

    Float & block_disconnected_client_timeout;
        /**< How long to block connections from disconnected clients
         * in seconds.
         */

    }; // NodeManager::NodeManagerSettings

/** @} */ // addtogroup node


} // namespace Massiv::Core
} // namespace Massiv


#endif // MASSIV_NODE_MANAGER_SETTINGS_H
