/** @file collect_group.cpp
 * Implementation of object group collecting operations.
 */

/*
 * begin        : Tue Oct 22 2002
 * copyright    : (C) 2002 by Petr Tovarys
 */

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it according to instructions in massiv/doc/licenses/source.txt.       *
 *                                                                         *
 ***************************************************************************/


#include "object/collect_group.h"
#include <algorithm>


namespace Massiv {
namespace Core {


//-----------------------------------------------------------------------------
// CollectObjectGroupOperation implementation.
//-----------------------------------------------------------------------------


CollectObjectGroupOperation::CollectObjectGroupOperation
    (
    ObjectShared::ObjectList & obj_list
    ) :
    objects( obj_list )
    {
    }


void CollectObjectGroupOperation::clear()
    {
    objects.clear();
    }


void CollectObjectGroupOperation::operator()
    (
    ObjectProperty * object
    )
    {
    hope( object != NULL );

    hope( std::find( objects.begin(), objects.end(), object ) == objects.end() );
    objects.push_back( object );
    }


}; // namespace Massiv::Core
}; // namespace Massiv
