/** @file event.cpp
 * Event.
 */

/*
 * begin        : Tue Mar 19 2002
 * copyright    : (C) 2001 by Petr Tovarys
 */

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it according to instructions in massiv/doc/licenses/source.txt.       *
 *                                                                         *
 ***************************************************************************/


#include "object/event.h"
#include "object/class_manager.h"
#include "global/global.h"
#include "utility/text_writer.h"


namespace Massiv {
namespace Core {


// Implementation of Event
// ~~~~~~~~~~~~~~~~~~~~~~~

void Event::bitstr_write
    (
    BitOStream &                    bos,
    const Serializer::Description & desc
    ) const
    {
    execution_time.bitstr_write( bos, desc );
    destination.bitstr_write( bos, desc );
    notify.bitstr_write( bos, desc );
    }


void Event::bitstr_read
    (
    BitIStream &                    bis,
    const Serializer::Description & desc
    )
    {
    execution_time.bitstr_read( bis, desc );
    destination.bitstr_read( bis, desc );
    notify.bitstr_read( bis, desc );
    }


void Event::text_write
    (
    TextWriter &                    tw,
    const Serializer::Description & desc
    ) const
    {
    execution_time.text_write( tw, desc );
    tw.write_space();
    destination.text_write( tw, desc );
    tw.write_space();
    notify.text_write( tw, desc );
    }


void Event::text_read
    (
    TextReader &                    tr,
    const Serializer::Description & desc
    )
    {
    execution_time.text_read( tr, desc );
    destination.text_read( tr, desc );
    notify.text_read( tr, desc );
    }


} // namespace Massiv::Core
} // namespace Massiv
