/** @file lib_exceptions_helper.cpp
 * Lib exceptions helper implementation
 */

/*
 * begin        : Sat Nov 1 2003
 * copyright    : (C) 2003 by Marek Vondrak
 */

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it according to instructions in massiv/doc/licenses/source.txt.       *
 *                                                                         *
 ***************************************************************************/


#include "core.h"
#include "object/lib/lib_exceptions.h"

namespace Massiv {
namespace Core {
namespace Lib {


// RaiseCoreLibException implementation
// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

template <class ExceptionName>
void RaiseCoreLibException<ExceptionName>::raise
    (
    const std::string & message
    )// throw( ExceptionName )
    {
    throw ExceptionName( message );
    }


// Instantiate the templates
// ~~~~~~~~~~~~~~~~~~~~~~~~~

template class MASSIV_EXPORTED RaiseCoreLibException<RuntimeException>;
template class MASSIV_EXPORTED RaiseCoreLibException<InvalidArgumentException>;
template class MASSIV_EXPORTED RaiseCoreLibException<CanNotAccessObjectException>;
template class MASSIV_EXPORTED RaiseCoreLibException<IllegalPointerConversionException>;
template class MASSIV_EXPORTED RaiseCoreLibException<ObjectNotOnLocalSystemException>;
template class MASSIV_EXPORTED RaiseCoreLibException<PointerPolicyViolationException>;
template class MASSIV_EXPORTED RaiseCoreLibException<RemoteCallFailedException>;
template class MASSIV_EXPORTED RaiseCoreLibException<UndefinedClassTypeException>;
template class MASSIV_EXPORTED RaiseCoreLibException<InvalidEventException>;
template class MASSIV_EXPORTED RaiseCoreLibException<AbstractClassException>;


} // namespace Massiv::Core::Lib
} // namespace Massiv::Core
} // namespace Massiv
