/** @file object_fwd.h
 * Various forward declarations for object model.
 */

/*
 * begin        : Sat Apr 13 2002
 * copyright    : (C) 2002 by Stepan Vondrak
 */

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it according to instructions in massiv/doc/licenses/source.txt.       *
 *                                                                         *
 ***************************************************************************/

#ifndef MASSIV_OBJECT_FWD_H
#define MASSIV_OBJECT_FWD_H


#ifndef MASSIV_COMMON_H
#include "global/common.h"
#endif

#ifndef MASSIV_TYPES_H
#include "utility/types.h"
#endif

#ifndef MASSIV_STYPE_FWD_H
#include "serializer/stype_fwd.h"  // ObjectVersion, ObjectName
#endif


namespace Massiv {
namespace Core {

/**
 * Object version.
 */
typedef SVlUInt32 ObjectVersion;

/**
 * Object name.
 */
typedef SString ObjectName;

// class_type_id.h

class ClassTypeId;

// objectid.h

class ObjectId;

// metaobject.h

class MetaObject;

// object_factory.h

class ObjectFactory;

// class_manager.h

class ClassManager;

// property.h

class Property;

// object_property.h

class ObjectProperty;

// object.h

class Object;

// object_status.h

class ObjectStatus;

// eventid.h, event.h, event_handle.h, local_schedule.h

class Event;
class EventId;
class EventHandle;
class LocalSchedule;

// archive.h

class Archive;

// rpc.h

class MethodPacket;
class RPCObject;
class RPCFailure;
class ResultObject;

// value_type.h

class ValueType;

// throwable.h

class Throwable;

} // namespace Massiv::Core
} // namespace Massiv


#endif // MASSIV_OBJECT_FWD_H
