/** @file object_property_data.cpp
 * Implementation of internal classes used by ObjectProperty and the core.
 */

/*
 * begin        : Thu Jul 24 2003
 * copyright    : (C) 2003 by Marek Vondrak
 */

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it according to instructions in massiv/doc/licenses/source.txt.       *
 *                                                                         *
 ***************************************************************************/

#include "object/object_property.h"
#include "object/object_property_data.h"
#include "time/system_time.h"

namespace Massiv {
namespace Core {


// Implementation of ObjectProperty::RootData
// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

ObjectProperty::RootData::RootData()
      : major_version( 0 ),
        consistent_replica( true ),
        gc_registered( false ),
        gc_finalizing( false ),
        gc_managed( true ),
        gc_root( false ),
        gc_disposing_root( false ),
        gc_pointer_update_pending( false ),
        gc_collect_pinned( false ),
        gc_shutdown( false ),
        gc_pin_count( 0 ),
        gc_ptr_pin_count( 0 ),
        touch_time( SystemTime::current_time() )
    {
    }


} // namespace Massiv::Core
} // namespace Massiv
