/** @file object_status_inline.h
 * Object status inline implementation.
 */

/*
 * begin        : Tue Mar 11 2003
 * copyright    : (C) 2003 by Petr Tovarys
 */

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it according to instructions in massiv/doc/licenses/source.txt.       *
 *                                                                         *
 ***************************************************************************/

 
namespace Massiv {
namespace Core {


ObjectStatus::ObjectStatus() :
    status( UNKNOWN )
    {
    }


ObjectStatus::ObjectStatus
    (
    Status  s
    ) :
    status( s )
    {
    }


ObjectStatus::ObjectStatus
    (
    const ObjectStatus & s
    ) :
    status( s.status )
    {
    }


ObjectStatus & ObjectStatus::operator=
    (
    const ObjectStatus & s
    )
    {
    set( s.status );
    return *this;
    }

bool ObjectStatus::operator==
    (
    const ObjectStatus & s
    ) const
    {
    return status == s.status;
    }


bool ObjectStatus::operator!=
    (
    const ObjectStatus & s
    ) const
    {
    return status != s.status;
    }


void ObjectStatus::set
    (
    Status _status
    )
    {
    status = _status;
    }


ObjectStatus::Status ObjectStatus::get_value() const
    {
    return status;
    }


} // namespace Massiv::Core
} // namespace Massiv
