/** @file rpc_inline.h
 * Remote procedure call-related stuff (inline methods).
 */

/*
 * begin        : May 2003
 * copyright    : (C) 2003 by Stepan Vondrak
 */

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it according to instructions in massiv/doc/licenses/source.txt.       *
 *                                                                         *
 ***************************************************************************/

namespace Massiv {
namespace Core {


// class MethodPacket

MethodPacket::MethodPacket()
    {
    }


MethodPacket::~MethodPacket()
    {
    }


// class RPCObject

bool RPCObject::is_request() const
    {
    return ( type == TYPE_REQUEST ) || ( type == TYPE_REPLICA_REQUEST );
    }


bool RPCObject::is_reply() const
    {
    return ( type == TYPE_REPLY ) || is_failure();
    }

    
bool RPCObject::is_failure() const
    {
    return ( type == TYPE_DELIVERY_FAILURE ) || ( type == TYPE_INTERFACE_FAILURE ) ||
           ( type == TYPE_EXCEPTION_FAILURE );
    }


bool RPCObject::has_data() const
    {
    return is_request() || ( is_reply() && !is_failure() );
    }


} // namespace Massiv::Core
} // namespace Massiv
