/** @file schedule_impl.h
 * Inline implementation of schedule stuff.
 */

/*
 * begin        : Thu Apr 25 2002
 * copyright    : (C) 2002 by Petr Tovarys
 */

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it according to instructions in massiv/doc/licenses/source.txt.       *
 *                                                                         *
 ***************************************************************************/


#ifndef MASSIV_SCHEDULE_IMPL_H
#define MASSIV_SCHEDULE_IMPL_H


#ifndef MASSIV_COMMON_H
#include "global/common.h"
#endif

#ifndef MASSIV_SCHEDULE_H
#include "object/schedule.h"
#endif

#ifndef MASSIV_OBJECT_H
#include "object/object.h"
#endif

#ifndef MASSIV_OBJECT_PROPERTY_DATA_H
#include "object/object_property_data.h"
#endif



namespace Massiv {
namespace Core {


// Implementation of GlobalScheduleIndexChanged
// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

inline void GlobalScheduleIndexChanged::operator()
    (
    ObjectProperty *    o,
    HeapIndex           new_index
    ) const
    {
    o->root_data->global_schedule_index = new_index;
    }


} // namespace Massiv::Core
} // namespace Massiv


#endif // MASSIV_SCHEDULE_IMPL_H
