/** @file stack_root_object.cpp
 * StackRootObject implementation.
 */

/*
 * begin        : Mon Jun 21 2003
 * copyright    : (C) 2003 by Marek Vondrak
 */

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it according to instructions in massiv/doc/licenses/source.txt.       *
 *                                                                         *
 ***************************************************************************/

#include "object/stack_root_object.h"
#include "object/object_property_data.h"
#include "property/property.h"
#include "serializer/serializer_fwd.h"
#include "utility/debug.h"
#include "utility/text_reader.h"
#include "utility/text_writer.h"


namespace Massiv {
namespace Core {


StackRootObject::StackRootObject() :
    ObjectProperty( StackRootTag() )
    {
    }


void StackRootObject::replica_time_advanced()
    {
    write_requested();
    }


void StackRootObject::initialize_from_owner
    (
    Property &          direct_owner,
    const Attributes &  attributes
    )
    {
    panic( "initialize_from_owner() is unsupported." );
    }


std::string StackRootObject::generated_name() const
    {
    return "stack_object$";
    }


void StackRootObject::for_each_owned_property_do
    (
    PropertyOperation & operation
    )
    {
    panic( "for_each_owned_property_do() is unsupported." );
    }


void StackRootObject::bitstr_write
    (
    BitOStream &                    bos,
    const Serializer::Description & desc
    ) const
    {
    panic( "bitstr_write() is unsupported." );
    }


void StackRootObject::bitstr_read
    (
    BitIStream &                    bis,
    const Serializer::Description & desc
    )
    {
    panic( "bitstr_read() is unsupported." );
    }


void StackRootObject::text_write
    (
    TextWriter &                    tw,
    const Serializer::Description & desc
    ) const
    {
    panic( "text_write() is unsupported." );
    }


void StackRootObject::text_read
    (
    TextReader &                    tr,
    const Serializer::Description & desc
    )
    {
    panic( "text_read() is unsupported." );
    }


} // namespace Massiv::Core
} // namespace Massiv
