/** @file core_default_casts.cpp
 * Instantions of DefaultCast templates for core mananaged classes.
 */

#include "pointer/default_cast_impl.h"
#include "object/rpc.h"
#include "object/value_type.h"
#include "object/throwable.h"
#include "object/lib/account_object_interface.h"
#include "object/lib/node_object_interface.h"


namespace Massiv {
namespace Core {


// Instantiate default casts for object pointers used in the core
// so that one can link against the core statically without the need for
// generating class_list if no managed classes are used at all (see factgen).

template class DefaultCast< ::Massiv::Core::Object >;
template class DefaultCast< ::Massiv::Core::RPCObject >;
template class DefaultCast< ::Massiv::Core::ResultObject >;
template class DefaultCast< ::Massiv::Core::ValueType >;
template class DefaultCast< ::Massiv::Core::Throwable >;
template class DefaultCast< ::Massiv::Core::Lib::AccountObjectInterface >;
template class DefaultCast< ::Massiv::Core::Lib::NodeObjectInterface >;


} // namespace Massiv::Core
} // namespace Massiv
