/** @file pointer_base.cpp
 * Object pointer base classes.
 */

/*
 * begin        : Nov 2003
 * copyright    : (C) 2003 by Stepan Vondrak
 */

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it according to instructions in massiv/doc/licenses/source.txt.       *
 *                                                                         *
 ***************************************************************************/

#include "object/object_property.h"
#include "pointer/pointer_base.h"
#include "serializer/serializer.h"
#include "system/system.h"


namespace Massiv {
namespace Core {


// Implementation of CommonPointerBase.
// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

void CommonPointerBase::check_strong_pointer_object_id
    (
    const Serializer::Description & desc,
    const ObjectId &                object_id
    )
    {
    if( !desc.source_node.is_null() &&
        desc.source_node.is_type( NodeId::TYPE_CLIENT ) &&
        Massiv::System::get_local_node_id().is_type( NodeId::TYPE_SERVER ) &&
        !object_id.is_null() )
        {
        std::ostringstream ss;
        ss << "Client tried to send strong pointer " << object_id << " to server node.";
        throw ExSerializationError( ss.str() );
        }
    }


// Implementation of PointerInfo.
// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

PointerInfo::~PointerInfo()
    {
    }


} // namespace Massiv::Core
} // namespace Massiv
