/** @file prop_bool.cpp
 * Boolean property.
 */

/*
 * begin        : Mon Apr 8 2002
 * copyright    : (C) 2002 by Stepan Vondrak
 */

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it according to instructions in massiv/doc/licenses/source.txt.       *
 *                                                                         *
 ***************************************************************************/

#include "global/common.h"
#include "property/prop_bool.h"
#include "serializer/serializer_bool.h"


namespace Massiv {
namespace Core {


std::string PBool::to_string() const
    {
    return read() ? "true" : "false";
    }


int PBool::hash() const
    {
    return read();
    }


int PBool::memory_size() const
    {
    return sizeof( *this );
    }


int PBool::bitstream_size() const
    {
    return 1;
    }


} // namespace Massiv::Core
} // namespace Massiv


#ifndef ENABLE_INLINE
#include "property/prop_bool_inline.h"
#endif
