/** @file prop_bool_inline.h
 * Boolean property.
 */

/*
 * begin        : Mon Apr 8 2002
 * copyright    : (C) 2002 by Stepan Vondrak
 */

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it according to instructions in massiv/doc/licenses/source.txt.       *
 *                                                                         *
 ***************************************************************************/

#ifndef MASSIV_SERIALIZER_BOOL_H
#include "serializer/serializer_bool.h"
#endif



namespace Massiv {
namespace Core {


PBool::PBool()
    {
    }


PBool::PBool
    (
    bool b
    ) : Super( b )
    {
    }


PBool::PBool
    (
    const PBool & b
    ) : Super( b )
    {
    }


PBool & PBool::operator=
    (
    bool b
    )
    {
    Super::operator=( b );
    return *this;
    }


PBool & PBool::operator=
    (
    const PBool & b
    )
    {
    operator=( b.read() );
    return *this;
    }


void PBool::bitstr_write
    (
    BitOStream &                    bos,
    const Serializer::Description &
    ) const
    {
    Serializer::BitStrBool::write( bos, read() );
    }


void PBool::bitstr_read
    (
    BitIStream &                    bis,
    const Serializer::Description &
    )
    {
    bool b;
    Serializer::BitStrBool::read( bis, b );
    write( b );
    }


void PBool::text_write
    (
    TextWriter &                    tw,
    const Serializer::Description &
    ) const
    {
    Serializer::TextBool::write( tw, read() );
    }


void PBool::text_read
    (
    TextReader &                    tr,
    const Serializer::Description &
    )
    {
    bool b;
    Serializer::TextBool::read( tr, b );
    write( b );
    }


} // namespace Massiv::Core
} // namespace Massiv
