/** @file prop_event_handle.cpp
 * Event handle property.
 */

/*
 * begin        : Sat Mar 23 2002
 * copyright    : (C) 2002 by Petr Tovarys
 */

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it according to instructions in massiv/doc/licenses/source.txt.       *
 *                                                                         *
 ***************************************************************************/

#include "prop_event_handle.h"
#include <sstream>

namespace Massiv {
namespace Core {


std::string PEventHandle::to_string() const
    {
    std::ostringstream ss;

    ss << read();
    return ss.str();
    }


int PEventHandle::hash() const
    {
    return EventHandle::Hash()( read() );
    }
    

int PEventHandle::memory_size() const
    {
    return sizeof( *this );
    }


int PEventHandle::bitstream_size() const
    {
    return sizeof( EventHandle ) * 8;
    }


} // namespace Massiv::Core
} // namespace Massiv


#ifndef ENABLE_INLINE
#include "prop_event_handle_inline.h"
#endif
