/** @file prop_event_handle_inline.h
 * Event handle property.
 */

/*
 * begin        : Sat Mar 23 2002
 * copyright    : (C) 2002 by Petr Tovarys
 */

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it according to instructions in massiv/doc/licenses/source.txt.       *
 *                                                                         *
 ***************************************************************************/

namespace Massiv {
namespace Core {


PEventHandle::PEventHandle()
    {
    }


PEventHandle::PEventHandle
    (
    const EventHandle & event_handle
    ) : Super( event_handle )
    {
    }


PEventHandle::PEventHandle
    (
    const PEventHandle & event_handle
    ) : Super( event_handle )
    {
    }


PEventHandle & PEventHandle::operator=
    (
    const EventHandle & event_handle
    )
    {
    Super::operator=( event_handle );
    return *this;
    }


PEventHandle & PEventHandle::operator=
    (
    const PEventHandle & event_handle
    )
    {
    operator=( event_handle.read() );
    return *this;
    }


void PEventHandle::kill()
    {
    EventHandle eh( read() );
    eh.kill();
    write( eh );
    }


void PEventHandle::clear()
    {
    EventHandle eh( read() );
    eh.clear();
    write( eh );
    }


void PEventHandle::bitstr_write
    (
    BitOStream &                    bos,
    const Serializer::Description & desc
    ) const
    {
    read().bitstr_write( bos, desc );
    }


void PEventHandle::bitstr_read
    (
    BitIStream &                    bis,
    const Serializer::Description & desc
    )
    {
    EventHandle eh;
    eh.bitstr_read( bis, desc );
    write( eh );
    }


void PEventHandle::text_write
    (
    TextWriter &                    tw,
    const Serializer::Description & desc
    ) const
    {
    read().text_write( tw, desc );
    }


void PEventHandle::text_read
    (
    TextReader &                    tr,
    const Serializer::Description & desc
    )
    {
    EventHandle eh;
    eh.text_read( tr, desc );
    write( eh );
    }


} // namespace Massiv::Core
} // namespace Massiv
