/** @file prop_string.cpp
 * String property.
 */

/*
 * begin        : Sun Oct 20 2002
 * copyright    : (C) 2002 by Martin Havlista
 */

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it according to instructions in massiv/doc/licenses/source.txt.       *
 *                                                                         *
 ***************************************************************************/

#include "global/common.h"
#include "utility/hash_function.h"
#include "property/prop_string.h"
#include <sstream>


namespace Massiv {
namespace Core {


std::string PString::to_string() const
    {
    std::ostringstream s;

    s << read();
    return s.str();
    }


int PString::hash() const
    {
    return ext::hash_string( read().c_str() );
    }


int PString::memory_size() const
    {
    return sizeof( *this ) + size() * sizeof( std::string::value_type );
    }


int PString::bitstream_size() const
    {
    return ( size() + 1 ) * sizeof( std::string::value_type ) * 8;
    }


} // namespace Massiv::Core
} // namespace Massiv


#ifndef ENABLE_INLINE
#include "property/prop_string_inline.h"
#endif
