/** @file prop_string_inline.h
 * String property.
 */

/*
 * begin        : Sun Oct 20 2002
 * copyright    : (C) 2002 by Martin Havlista
 */

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it according to instructions in massiv/doc/licenses/source.txt.       *
 *                                                                         *
 ***************************************************************************/

#ifndef MASSIV_SERIALIZER_STRING_H
#include "serializer/serializer_string.h"
#endif



namespace Massiv {
namespace Core {


PString::PString()
    {
    }


PString::PString
    (
    const std::string & value
    ) : Super( value )
    {
    }


PString::PString
    (
    const PString & s
    ) : Super( s )
    {
    }


PString & PString::operator=
    (
    const std::string & value
    )
    {
    Super::operator=( value );
    return *this;
    }


PString & PString::operator=
    (
    const PString & s
    )
    {
    operator=( s.read() );
    return *this;
    }


void PString::bitstr_write
    (
    BitOStream &                    bos,
    const Serializer::Description &
    ) const
    {
    Serializer::BitStrString::write( bos, read() );
    }


void PString::bitstr_read
    (
    BitIStream &                    bis,
    const Serializer::Description & desc
    )
    {
    std::string temp;
    Serializer::BitStrString::read( bis, temp );
    write( temp );
    }


void PString::text_write
    (
    TextWriter &                    tw,
    const Serializer::Description & desc
    ) const
    {
    Serializer::TextString::write( tw, read() );
    }


void PString::text_read
    (
    TextReader &                    tr,
    const Serializer::Description & desc
    )
    {
    std::string temp;
    Serializer::TextString::read( tr, temp );
    write( temp );
    }


} // namespace Massiv::Core
} // namespace Massiv
