/** @file prop_time.cpp
 * Time property implementation.
 */

/*
 * begin        : Fri Mar 22 2002
 * copyright    : (C) 2002 by Petr Tovarys
 */

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it according to instructions in massiv/doc/licenses/source.txt.       *
 *                                                                         *
 ***************************************************************************/

#include "global/common.h"
#include "property/prop_time.h"
#include <sstream>


namespace Massiv {
namespace Core {


template <class VTime>
std::string PVirtualTime<VTime>::to_string() const
    {
    std::ostringstream ss;
    ss << read();
    return ss.str();
    }


template <class VTime>
int PVirtualTime<VTime>::hash() const
    {
    return static_cast<int>( read().get_value() );
    }


template <class VTime>
int PVirtualTime<VTime>::memory_size() const
    {
    return sizeof( *this );
    }


template <class VTime>
int PVirtualTime<VTime>::bitstream_size() const
    {
    return sizeof( VTime ) * 8;
    }


} // namespace Massiv::Core
} // namespace Massiv


#ifndef ENABLE_INLINE
#include "property/prop_time_inline.h"
#endif


// Instantiate PTime template.

namespace Massiv {
namespace Core {

template class MASSIV_EXPORTED PVirtualTime<STime>;

} // namespace Massiv::Core
} // namespace Massiv
