/** @file replica_client_inline.h
 * Replication client.
 */

/*
 * begin        : Feb 2003
 * copyright    : (C) 2003 by Stepan Vondrak
 */

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it according to instructions in massiv/doc/licenses/source.txt.       *
 *                                                                         *
 ***************************************************************************/

namespace Massiv {
namespace Core {


// class ReplicaClient

ReplicaClient::NodeInfo & ReplicaClient::access_node
    (
    const NodeId &      node_id
    )
    {
    NodeInfo::HashMap::iterator result = nodes.find( node_id );
    if( result == nodes.end() )
        {
        result = insert_node( node_id );
        }

    return result->second;
    }


ReplicaClient::NodeInfo::HashMap::iterator ReplicaClient::insert_node
    (
    const NodeId &      node_id
    )
    {
    std::pair< NodeInfo::HashMap::iterator, bool > result =
        nodes.insert( NodeInfo::HashMap::value_type( node_id, NodeInfo( node_id ) ) );
    hope( result.second );
    return result.first;
    }


} // namespace Massiv::Core
} // namespace Massiv

