/** @file replica_server_inline.h
 * Replication server.
 */

/*
 * begin        : Sat Feb 01 2003
 * copyright    : (C) 2003 by Stepan Vondrak
 */

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it according to instructions in massiv/doc/licenses/source.txt.       *
 *                                                                         *
 ***************************************************************************/

namespace Massiv {
namespace Core {


// class ReplicaServer::NodeInfo

bool ReplicaServer::NodeInfo::is_empty() const
    {
    return requests.empty() && pending_updates.is_empty() && versions.empty();
    }


// class ReplicaServer

const ReplicaTime & ReplicaServer::get_replica_time() const
    {
    return replica_time;
    }


ReplicaServer::NodeInfo & ReplicaServer::access_node
    (
    const NodeId &      node_id
    )
    {
    NodeInfo::HashMap::iterator result = nodes.find( node_id );
    if( result == nodes.end() )
        {
        result = insert_node( node_id );
        }

    return result->second;
    }


} // namespace Massiv::Core
} // namespace Massiv
