/** @file replica_time_inline.h
 * Replication timestamp inline implementation.
 */

/*
 * begin        : Mar 2003
 * copyright    : (C) 2003 by Stepan Vondrak
 */

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it according to instructions in massiv/doc/licenses/source.txt.       *
 *                                                                         *
 ***************************************************************************/

#ifndef MASSIV_SERIALIZER_INT_H
#include "serializer/serializer_int.h"
#endif

namespace Massiv {
namespace Core {


ReplicaTime::ReplicaTime()
    {
    }


ReplicaTime::ReplicaTime
    (
    TimeType t
    ) : Super( t )
    {
    }


ReplicaTime::ReplicaTime
    (
    const ReplicaTime & t
    ) : Super( t )
    {
    }


ReplicaTime & ReplicaTime::operator=
    (
    const ReplicaTime & t
    )
    {
    Super::operator=( t );
    return *this;
    }


void ReplicaTime::bitstr_write
    (
    BitOStream &                    bos,
    const Serializer::Description &
    ) const
    {
    Serializer::BitStrInt::write( bos, get_value(), 32 );
    }


void ReplicaTime::bitstr_read
    (
    BitIStream &                    bis,
    const Serializer::Description &
    )
    {
    TimeType temp;
    Serializer::BitStrInt::read( bis, temp, 32 );
    set_value( temp );
    }


void ReplicaTime::text_write
    (
    TextWriter &                    tw,
    const Serializer::Description &
    ) const
    {
    Serializer::TextInt::write( tw, get_value(), 32 );
    }


void ReplicaTime::text_read
    (
    TextReader &                    tr,
    const Serializer::Description &
    )
    {
    TimeType temp;
    Serializer::TextInt::read( tr, temp, 32 );
    set_value( temp );
    }

    
} // namespace Massiv::Core
} // namespace Massiv
