/** @file replication_fwd.h
 * Replication forward stuff.
 */

/*
 * begin        : Feb 2003
 * copyright    : (C) 2003 by Stepan Vondrak
 */

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it according to instructions in massiv/doc/licenses/source.txt.       *
 *                                                                         *
 ***************************************************************************/

#ifndef MASSIV_REPLICATION_FWD_H
#define MASSIV_REPLICATION_FWD_H


namespace Massiv {
namespace Core {


/** @def DEBUG_REPLICATION
 * Define this to enable delta-update protocol debugging messages.
 * If this macro is defined, debuggin messages can be disabled by settings
 * cvar (messages won't even be created) or via logger filtering. If this
 * macro is not defined, code generating the messages will not be compiled
 * at all.
 *
 * @ingroup replication
 */
#define DEBUG_REPLICATION


// replica_client.h

class ReplicaClient;

// replica_client_stats.h

class ReplicaClientNodeStatistics;
class ReplicaClientStatistics;

// replica_group_set.h

class ReplicationGroupSet;

// replica_manager.h

class ReplicaManager;

// replica_request.h

class ReplicaRequest;
class ReplicaRequests;

// replica_server.h

class ReplicaServer;

// replica_server_stats.h

class ReplicaServerNodeStatistics;
class ReplicaServerStatistics;

// replica_time.h

class ReplicaTime;

// replica_update.h

class ReplicaUpdateInfo;
class ReplicaUpdateBacklog;

// replica_version.h

class ReplicaVersion;
class ReplicaVersions;

// replication_settings.h

class ReplicationSettings;


} // namespace Massiv::Core
} // namespace Massiv


#endif // MASSIV_REPLICATION_FWD_H
