/** @file bitint_masks.h
 * Precomputed bitint masks.
 */

/*
 * begin        : Wed Mar 19 2003
 * copyright    : (C) 2003 by Marek Vondrak
 */

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it according to instructions in massiv/doc/licenses/source.txt.       *
 *                                                                         *
 ***************************************************************************/

#ifndef MASSIV_BITINT_TRAITS_H
#include "utility/bitint_traits.h"
#endif


static const Massiv::Core::UInt32 uint32_masks[] =
    {
    Massiv::Core::BitInt_Traits<Massiv::Core::UInt32, 0>::mask(),
    Massiv::Core::BitInt_Traits<Massiv::Core::UInt32, 1>::mask(),
    Massiv::Core::BitInt_Traits<Massiv::Core::UInt32, 2>::mask(),
    Massiv::Core::BitInt_Traits<Massiv::Core::UInt32, 3>::mask(),
    Massiv::Core::BitInt_Traits<Massiv::Core::UInt32, 4>::mask(),
    Massiv::Core::BitInt_Traits<Massiv::Core::UInt32, 5>::mask(),
    Massiv::Core::BitInt_Traits<Massiv::Core::UInt32, 6>::mask(),
    Massiv::Core::BitInt_Traits<Massiv::Core::UInt32, 7>::mask(),
    Massiv::Core::BitInt_Traits<Massiv::Core::UInt32, 8>::mask(),
    Massiv::Core::BitInt_Traits<Massiv::Core::UInt32, 9>::mask(),
    Massiv::Core::BitInt_Traits<Massiv::Core::UInt32, 10>::mask(),
    Massiv::Core::BitInt_Traits<Massiv::Core::UInt32, 11>::mask(),
    Massiv::Core::BitInt_Traits<Massiv::Core::UInt32, 12>::mask(),
    Massiv::Core::BitInt_Traits<Massiv::Core::UInt32, 13>::mask(),
    Massiv::Core::BitInt_Traits<Massiv::Core::UInt32, 14>::mask(),
    Massiv::Core::BitInt_Traits<Massiv::Core::UInt32, 15>::mask(),
    Massiv::Core::BitInt_Traits<Massiv::Core::UInt32, 16>::mask(),
    Massiv::Core::BitInt_Traits<Massiv::Core::UInt32, 17>::mask(),
    Massiv::Core::BitInt_Traits<Massiv::Core::UInt32, 18>::mask(),
    Massiv::Core::BitInt_Traits<Massiv::Core::UInt32, 19>::mask(),
    Massiv::Core::BitInt_Traits<Massiv::Core::UInt32, 20>::mask(),
    Massiv::Core::BitInt_Traits<Massiv::Core::UInt32, 21>::mask(),
    Massiv::Core::BitInt_Traits<Massiv::Core::UInt32, 22>::mask(),
    Massiv::Core::BitInt_Traits<Massiv::Core::UInt32, 23>::mask(),
    Massiv::Core::BitInt_Traits<Massiv::Core::UInt32, 24>::mask(),
    Massiv::Core::BitInt_Traits<Massiv::Core::UInt32, 25>::mask(),
    Massiv::Core::BitInt_Traits<Massiv::Core::UInt32, 26>::mask(),
    Massiv::Core::BitInt_Traits<Massiv::Core::UInt32, 27>::mask(),
    Massiv::Core::BitInt_Traits<Massiv::Core::UInt32, 28>::mask(),
    Massiv::Core::BitInt_Traits<Massiv::Core::UInt32, 29>::mask(),
    Massiv::Core::BitInt_Traits<Massiv::Core::UInt32, 30>::mask(),
    Massiv::Core::BitInt_Traits<Massiv::Core::UInt32, 31>::mask(),
    Massiv::Core::BitInt_Traits<Massiv::Core::UInt32, 32>::mask()
    };

static const Massiv::Core::UInt64 uint64_masks[] =
    {
    Massiv::Core::BitInt_Traits<Massiv::Core::UInt64, 0>::mask(),
    Massiv::Core::BitInt_Traits<Massiv::Core::UInt64, 1>::mask(),
    Massiv::Core::BitInt_Traits<Massiv::Core::UInt64, 2>::mask(),
    Massiv::Core::BitInt_Traits<Massiv::Core::UInt64, 3>::mask(),
    Massiv::Core::BitInt_Traits<Massiv::Core::UInt64, 4>::mask(),
    Massiv::Core::BitInt_Traits<Massiv::Core::UInt64, 5>::mask(),
    Massiv::Core::BitInt_Traits<Massiv::Core::UInt64, 6>::mask(),
    Massiv::Core::BitInt_Traits<Massiv::Core::UInt64, 7>::mask(),
    Massiv::Core::BitInt_Traits<Massiv::Core::UInt64, 8>::mask(),
    Massiv::Core::BitInt_Traits<Massiv::Core::UInt64, 9>::mask(),
    Massiv::Core::BitInt_Traits<Massiv::Core::UInt64, 10>::mask(),
    Massiv::Core::BitInt_Traits<Massiv::Core::UInt64, 11>::mask(),
    Massiv::Core::BitInt_Traits<Massiv::Core::UInt64, 12>::mask(),
    Massiv::Core::BitInt_Traits<Massiv::Core::UInt64, 13>::mask(),
    Massiv::Core::BitInt_Traits<Massiv::Core::UInt64, 14>::mask(),
    Massiv::Core::BitInt_Traits<Massiv::Core::UInt64, 15>::mask(),
    Massiv::Core::BitInt_Traits<Massiv::Core::UInt64, 16>::mask(),
    Massiv::Core::BitInt_Traits<Massiv::Core::UInt64, 17>::mask(),
    Massiv::Core::BitInt_Traits<Massiv::Core::UInt64, 18>::mask(),
    Massiv::Core::BitInt_Traits<Massiv::Core::UInt64, 19>::mask(),
    Massiv::Core::BitInt_Traits<Massiv::Core::UInt64, 20>::mask(),
    Massiv::Core::BitInt_Traits<Massiv::Core::UInt64, 21>::mask(),
    Massiv::Core::BitInt_Traits<Massiv::Core::UInt64, 22>::mask(),
    Massiv::Core::BitInt_Traits<Massiv::Core::UInt64, 23>::mask(),
    Massiv::Core::BitInt_Traits<Massiv::Core::UInt64, 24>::mask(),
    Massiv::Core::BitInt_Traits<Massiv::Core::UInt64, 25>::mask(),
    Massiv::Core::BitInt_Traits<Massiv::Core::UInt64, 26>::mask(),
    Massiv::Core::BitInt_Traits<Massiv::Core::UInt64, 27>::mask(),
    Massiv::Core::BitInt_Traits<Massiv::Core::UInt64, 28>::mask(),
    Massiv::Core::BitInt_Traits<Massiv::Core::UInt64, 29>::mask(),
    Massiv::Core::BitInt_Traits<Massiv::Core::UInt64, 30>::mask(),
    Massiv::Core::BitInt_Traits<Massiv::Core::UInt64, 31>::mask(),
    Massiv::Core::BitInt_Traits<Massiv::Core::UInt64, 32>::mask(),
    
    Massiv::Core::BitInt_Traits<Massiv::Core::UInt64, 33>::mask(),
    Massiv::Core::BitInt_Traits<Massiv::Core::UInt64, 34>::mask(),
    Massiv::Core::BitInt_Traits<Massiv::Core::UInt64, 35>::mask(),
    Massiv::Core::BitInt_Traits<Massiv::Core::UInt64, 36>::mask(),
    Massiv::Core::BitInt_Traits<Massiv::Core::UInt64, 37>::mask(),
    Massiv::Core::BitInt_Traits<Massiv::Core::UInt64, 38>::mask(),
    Massiv::Core::BitInt_Traits<Massiv::Core::UInt64, 39>::mask(),
    Massiv::Core::BitInt_Traits<Massiv::Core::UInt64, 40>::mask(),
    Massiv::Core::BitInt_Traits<Massiv::Core::UInt64, 41>::mask(),
    Massiv::Core::BitInt_Traits<Massiv::Core::UInt64, 42>::mask(),
    Massiv::Core::BitInt_Traits<Massiv::Core::UInt64, 43>::mask(),
    Massiv::Core::BitInt_Traits<Massiv::Core::UInt64, 44>::mask(),
    Massiv::Core::BitInt_Traits<Massiv::Core::UInt64, 45>::mask(),
    Massiv::Core::BitInt_Traits<Massiv::Core::UInt64, 46>::mask(),
    Massiv::Core::BitInt_Traits<Massiv::Core::UInt64, 47>::mask(),
    Massiv::Core::BitInt_Traits<Massiv::Core::UInt64, 48>::mask(),
    Massiv::Core::BitInt_Traits<Massiv::Core::UInt64, 49>::mask(),
    Massiv::Core::BitInt_Traits<Massiv::Core::UInt64, 50>::mask(),
    Massiv::Core::BitInt_Traits<Massiv::Core::UInt64, 51>::mask(),
    Massiv::Core::BitInt_Traits<Massiv::Core::UInt64, 52>::mask(),
    Massiv::Core::BitInt_Traits<Massiv::Core::UInt64, 53>::mask(),
    Massiv::Core::BitInt_Traits<Massiv::Core::UInt64, 54>::mask(),
    Massiv::Core::BitInt_Traits<Massiv::Core::UInt64, 55>::mask(),
    Massiv::Core::BitInt_Traits<Massiv::Core::UInt64, 56>::mask(),
    Massiv::Core::BitInt_Traits<Massiv::Core::UInt64, 57>::mask(),
    Massiv::Core::BitInt_Traits<Massiv::Core::UInt64, 58>::mask(),
    Massiv::Core::BitInt_Traits<Massiv::Core::UInt64, 59>::mask(),
    Massiv::Core::BitInt_Traits<Massiv::Core::UInt64, 60>::mask(),
    Massiv::Core::BitInt_Traits<Massiv::Core::UInt64, 61>::mask(),
    Massiv::Core::BitInt_Traits<Massiv::Core::UInt64, 62>::mask(),
    Massiv::Core::BitInt_Traits<Massiv::Core::UInt64, 63>::mask(),
    Massiv::Core::BitInt_Traits<Massiv::Core::UInt64, 64>::mask()
    };
