/** @file serializer_bool.cpp
 * Boolean serializers.
 */

/*
 * begin        : Sun Apr 21 2002
 * copyright    : (C) 2002 by Stepan Vondrak
 */

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it according to instructions in massiv/doc/licenses/source.txt.       *
 *                                                                         *
 ***************************************************************************/

#include "global/common.h"
#include "utility/text_writer.h"
#include "utility/text_reader.h"
#include "serializer/serializer_bool.h"


namespace Massiv {
namespace Core {
namespace Serializer {


void TextBool::read
    (
    TextReader &    tr,
    bool &          value
    )
    {
    std::string     s;
    std::istream &  is = tr.line();

    //hope( is );
    is >> s;
    if( s == "true" )
        {
        value = true;
        }
    else if( s == "false" )
        {
        value = false;
        }
    else
        {
        if( is.eof() )
            throw ExUnexpectedEol( tr.unexpected_eol() );
        else if( is.fail() )
            throw ExUnexpectedToken( tr.unexpected_token( "true or false" ) );
        else
            throw ExUnexpectedValue( tr.unexpected_value( "true or false", s ) );
        }
    }


} // namespace Massiv::Core::Serializer
} // namespace Massiv::Core
} // namespace Massiv


#ifndef EXPOSE_SERIALIZERS
#include "serializer/serializer_bool_inline.h"
#endif
