/** @file serializer_bool_inline.h
 * Boolean serializers.
 */

/*
 * begin        : Sun Apr 21 2002
 * copyright    : (C) 2002 by Stepan Vondrak
 */

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it according to instructions in massiv/doc/licenses/source.txt.       *
 *                                                                         *
 ***************************************************************************/

#ifndef MASSIV_BITISTREAM_H
#include "net/bitistream.h"
#endif

#ifndef MASSIV_BITOSTREAM_H
#include "net/bitostream.h"
#endif

#ifndef MASSIV_TEXT_READER_H
#include "utility/text_reader.h"
#endif

#ifndef MASSIV_TEXT_WRITER_H
#include "utility/text_writer.h"
#endif



namespace Massiv {
namespace Core {
namespace Serializer {


void BitStrBool::read
    (
    BitIStream &   bis,
    bool &         result
    )
    {
    result = ( bis.read_int( 1 ) ? true : false );
    }


void BitStrBool::write
    (
    BitOStream &   bos,
    bool           value
    )
    {
    bos.write_int( value ? 1 : 0, 1 );
    }


void TextBool::write
    (
    TextWriter &    tw,
    bool            value
    )
    {
    tw.line() << ( value ? "true" : "false" );
    }


} // namespace Massiv::Core::Serializer
} // namespace Massiv::Core
} // namespace Massiv
