/** @file serializer_float_inline.h
 * Floating-point serializers.
 */

/*
 * begin        : Thu Feb 21 2002
 * copyright    : (C) 2002 by Stepan Vondrak
 */

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it according to instructions in massiv/doc/licenses/source.txt.       *
 *                                                                         *
 ***************************************************************************/

#ifndef MASSIV_BITISTREAM_H
#include "net/bitistream.h"
#endif

#ifndef MASSIV_BITOSTREAM_H
#include "net/bitostream.h"
#endif

#ifndef MASSIV_TEXT_READER_H
#include "utility/text_reader.h"
#endif

#ifndef MASSIV_TEXT_WRITER_H
#include "utility/text_writer.h"
#endif


namespace Massiv {
namespace Core {
namespace Serializer {


void BitStrFloat::read
    (
    BitIStream &    bis,
    Float32 &       result
    )
    {
    result = bis.read_float();
    }


void BitStrFloat::read
    (
    BitIStream &    bis,
    Float64 &       result
    )
    {
    result = bis.read_float64();
    }


void BitStrFloat::write
    (
    BitOStream &    bos,
    Float32         value
    )
    {
    bos.write_float( value );
    }


void BitStrFloat::write
    (
    BitOStream &    bos,
    Float64         value
    )
    {
    bos.write_float64( value );
    }

    
void TextFloat::write
    (
    TextWriter &    tw,
    Float32         value
    )
    {
    tw.line() << value;
    }


void TextFloat::write
    (
    TextWriter &    tw,
    Float64         value
    )
    {
    tw.line() << value;
    }


} // namespace Massiv::Core::Serializer
} // namespace Massiv::Core
} // namespace Massiv
