/** @file serializer_fwd.h
 * Serializer forward declarations.
 * @todo explicitne vypsat podminky, jak musi serializer fungovat
 *       (napr. vyjimka musi zanechat property v puvodnim stavu, ...)
 */

/*
 * begin        : Sun May 12 2002
 * copyright    : (C) 2002 by Stepan Vondrak
 */

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it according to instructions in massiv/doc/licenses/source.txt.       *
 *                                                                         *
 ***************************************************************************/

#ifndef MASSIV_SERIALIZER_FWD_H
#define MASSIV_SERIALIZER_FWD_H

//
// Serializer subsystem setup.
//

#ifdef ENABLE_INLINE

/** @def EXPOSE_SERIALIZERS
 * Should serializer implementation be exposed to client code?
 * Note that enabling this pulls in a lot of internal core classes like
 * bitstreams, textstreams, arrays, exceptions, ...
 */
//#define EXPOSE_SERIALIZERS

#endif // ENABLE_INLINE

#ifdef EXPOSE_SERIALIZERS
#define SERIALIZER_INLINE   INLINE
#else
#define SERIALIZER_INLINE
#endif

//
// Forward declarations.
//

#ifndef MASSIV_BITIOSTREAM_FWD_H
#include "net/bitiostream_fwd.h"
#endif

namespace Massiv {
namespace Core {

namespace Serializer {

struct Description;

} // namespace Massiv::Core::Serializer

class TextReader;
class TextWriter;

} // namespace Massiv::Core
} // namespace Massiv

#endif // MASSIV_SERIALIZER_FWD_H
