/** @file serializer_inline.h
 * Serialization.
 */

/*
 * begin        : Sun May 12 2002
 * copyright    : (C) 2002 by Stepan Vondrak
 */

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it according to instructions in massiv/doc/licenses/source.txt.       *
 *                                                                         *
 ***************************************************************************/


namespace Massiv {
namespace Core {
namespace Serializer {


Description::Description()
    : compare_times( false ),
      repflags_yes( REPMASK_MIGRATE_YES ),
      repflags_no( REPMASK_MIGRATE_NO ),
      lossy( false ),
      object_flags( OBJECT_DEFAULT )
    {
    }

    
bool Description::replication_flags_match
    (
    int repflags
    ) const
    {
    hope( !repflags || flags_on( repflags, REPFLAGS_MIGRATE ) );
    hope( only_lower_bits( repflags, REPFLAGS_BITS ) );

    return flags_on( repflags, repflags_yes, repflags_no );
    }


} // namespace Massiv::Core::Serializer
} // namespace Massiv::Core
} // namespace Massiv
