/** @file serializer_string.cpp
 * String serializers.
 */

/*
 * begin        : Sun Oct 20 2002
 * copyright    : (C) 2002 by Martin Havlista
 */

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it according to instructions in massiv/doc/licenses/source.txt.       *
 *                                                                         *
 ***************************************************************************/

#include "global/common.h"
#include "utility/quote_string.h"
#include "utility/text_reader.h"
#include "serializer/serializer_string.h"


namespace Massiv {
namespace Core {
namespace Serializer {


void TextString::read
    (
    TextReader &    tr,
    std::string &   value
    )
    {
    std::istream &  is = tr.line();
    //hope( is );
    is >> quote_string( value );
    if( is.fail() )
        {
        if( is.eof() )
            {
            throw ExUnexpectedEol( tr.unexpected_eol() );
            }
        else
            {
            throw ExUnexpectedValue( tr.unexpected_token( "quoted string" ) );
            }
        }
    }


} // namespace Massiv::Core::Serializer
} // namespace Massiv::Core
} // namespace Massiv


#ifndef EXPOSE_SERIALIZERS
#include "serializer/serializer_string_inline.h"
#endif
