/** @file serializer_string_inline.h
 * String serializers.
 */

/*
 * begin        : Sun Oct 20 2002
 * copyright    : (C) 2002 by Martin Havlista
 */

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it according to instructions in massiv/doc/licenses/source.txt.       *
 *                                                                         *
 ***************************************************************************/

#ifndef MASSIV_BITISTREAM_H
#include "net/bitistream.h"
#endif

#ifndef MASSIV_BITOSTREAM_H
#include "net/bitostream.h"
#endif

#ifndef MASSIV_TEXT_READER_H
#include "utility/text_reader.h"
#endif

#ifndef MASSIV_TEXT_WRITER_H
#include "utility/text_writer.h"
#endif

#ifndef MASSIV_QUOTE_STRING_H
#include "utility/quote_string.h"
#endif


namespace Massiv {
namespace Core {
namespace Serializer {


void BitStrString::read
    (
    BitIStream &    bis,
    std::string &   result
    )
    {
    result = bis.read_string();
    }


void BitStrString::write
    (
    BitOStream &            bos,
    const std::string &     value
    )
    {
    bos.write_string( value );
    }


void TextString::write
    (
    TextWriter &            tw,
    const std::string &     value
    )
    {
    tw.line() << quote_const_string( value );
    }


} // namespace Massiv::Core::Serializer
} // namespace Massiv::Core
} // namespace Massiv
