/** @file status_inline.h
 * Status (inline methods).
 */

/*
 * begin        : Jun 2003
 * copyright    : (C) 2003 by Stepan Vondrak
 */

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it according to instructions in massiv/doc/licenses/source.txt.       *
 *                                                                         *
 ***************************************************************************/


namespace Massiv {
namespace Core {


Status Status::debug
    (
    Facility    facility,
    Priority    priority
    )
    {
    return Status( facility, TYPE_DEBUG, priority );
    }


Status Status::info
    (
    Facility    facility,
    Priority    priority
    )
    {
    return Status( facility, TYPE_INFO, priority );
    }


Status Status::warning
    (
    Facility    facility,
    Priority    priority
    )
    {
    return Status( facility, TYPE_WARNING, priority );
    }


Status Status::error
    (
    Facility    facility,
    Priority    priority
    )
    {
    return Status( facility, TYPE_ERROR, priority );
    }


} // namespace Massiv::Core
} // namespace Massiv
