/** @file system_event.cpp
 * System event common stuff.
 */

/*
 * begin        : Wed Apr 17 2002
 * copyright    : (C) 2002 by Petr Tovarys
 */

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it according to instructions in massiv/doc/licenses/source.txt.       *
 *                                                                         *
 ***************************************************************************/


#include "sysevent/system_event.h"
#include "sysevent/system_msg.h"
#include <stddef.h>


namespace Massiv {
namespace Core {


SystemEvent::SystemEvent() :
    type( INVALID )
    {
    }


SystemEvent::SystemEvent
    (
    const SystemEvent & e
    ) :
    type( e.type ),
    system_msg( e.system_msg )
    {
    }


SystemEvent & SystemEvent::operator=
    (
    const SystemEvent & e
    )
    {
    type        = e.type;
    system_msg  = e.system_msg;
    return *this;
    }


void SystemEvent::execute()
    {
    switch( type )
        {
        case SYSTEM_MESSAGE:
            hope( !system_msg.is_null() );
            system_msg->execute();
            break;
        default:
            /** @todo FIXME Log? Throw exception? */
            hope( false );
            break;
        }
    }


}; // namespace Massiv::Core
}; // namespace Massiv
