/** @file system_event_fwd.h
 * Various forward declarations for system events and messages.
 */

/*
 * begin        : Tue May 14 2002
 * copyright    : (C) 2002 by Petr Tovarys
 */

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it according to instructions in massiv/doc/licenses/source.txt.       *
 *                                                                         *
 ***************************************************************************/

#ifndef MASSIV_SYSTEM_EVENT_FWD_H
#define MASSIV_SYSTEM_EVENT_FWD_H


#ifndef MASSIV_COMMON_H
#include "global/common.h"
#endif


namespace Massiv {
namespace Core {


// system_msg.h
class SystemMessage;

// find_object_msg.h
class FindObjectMessage;

// migration_group_msg.h
class MigrationGroupMessage;

// global_search_msg.h
class GlobalSearchMessage;
class GlobalSearchReplyMessage;

// replication_msg.h
class ReplicationUpdateMessage;
class ReplicationAckMessage;

// object_status_msg.h
class ObjectStatusMessage;

// forward_msg.h
class ForwardMessage;
class ForwardedMessage;

// archivation_msg.h
class ArchivationStatusMessage;

// time_synchronization_msg.h
class TimeSynchronizationMessage;
class TimeMagicConstantMessage;

// simulation_sync_msg.h
class StartupMessage;

// data_msg.h
class DataVersionRequestMessage;
class DataRequestMessage;
class DataVersionMessage;
class DataMessage;
class DataConfirmationMessage;
class DataErrorMessage;
class DataUpdateRequestMessage;

// client_connection_msg.h
class WelcomeMessage;
class AcceptClientMessage;
class ClientAcceptedMessage;
class ClientReadyMessage;
class ClientReadyReplyMessage;
class KillClientMessage;

// account_msg.h
class AccountRegisterRequestMessage;
class AccountRegisterRespondMessage;
class AccountCreateRequestMessage;
class AccountCreateRespondMessage;

// node_action_msg.h
class NodeActionMessage;
class NodeActionRequestMessage;
class NodeActionRequestReplyMessage;
class NodeActionCoordinatorSelectedMessage;
class NodeActionPrepareFinishMessage;
class NodeActionPrepareFinishReplyMessage;
class NodeActionFinishMessage;

// balancer_msg.h
class ResourceLoadMessage;


} // namespace Massiv::Core
} // namespace Massiv


#endif // MASSIV_SYSTEM_EVENT_FWD_H
