/** @file main.cpp
 * Testing data management.
 */

/*
 * begin        : Sun Feb 09 2003
 * copyright    : (C) 2003 by Martin Havlista
 */

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it according to instructions in massiv/doc/licenses/source.txt.       *
 *                                                                         *
 ***************************************************************************/

#include "global/common.h"
#include "global/global.h"
#include "status/exception.h"
#include "test/data_test/data_test.h"
#include <iosfwd>

using namespace Massiv::Core;
using namespace Massiv::Core::Test;


int main()
    {
    try
        {
        DataTest    data_test;
        data_test.run();
        }
    catch( std::exception & e )
        {
        std::cout << "Unhandled exception leaked" << std::endl;
        std::cout << e.what() << std::endl;
        exit( 1 );
        }
    catch( ... )
        {
        std::cout << "Unhandled exception leaked, no message available.";
        std::cout << std::endl;
        exit( 1 );
        }
    
    return 0;
    }
