/** @file test_array.cpp
 * Array testings.
 */

/*
 * begin        : Tue Apr 10 2002
 * copyright    : (C) 2002 by Marek Vondrak
 */

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it according to instructions in massiv/doc/licenses/source.txt.       *
 *                                                                         *
 ***************************************************************************/

#include "test/test_array.h"
#include "utility/array.h"

using namespace Massiv::Core::Test;
using namespace Massiv::Core;

namespace Massiv {
namespace Core {
namespace Test {


ArrayTest::ArrayTest() :
    Test( "array" )
    {
    }


ArrayTest::~ArrayTest()
    {
    }


void ArrayTest::test()
    {
    int c_array[] = { 1, 2, 3, 4, 5 };
    NormalizedArray< StaticStorage<int, 10> >               a;
    NormalizedArray< DynamicStorage<int> >                  b;
    NormalizedArray< SharedStorage< DynamicStorage<int> > > c;
    NormalizedArray< SharedStorage< DynamicStorage<int> > > d;
    NormalizedArray< UnmanagedStorage<int> >                e;

    a.push_back( 1 );
    a.push_back( 2 );
    a.push_back( 3 );

    test_condition_( a.size() == 3 );
    test_condition_( a[0] == 1 );

    b.push_back( 1 );

    c.push_back( 4 );
    c.push_back( 3 );
    c.push_back( 2 );
    c.push_back( 1 );

    b = c;
    test_condition_( b == c );

    d = c;

    test_condition_( c[0] == 4 );
    d[0] = 5;
    test_condition_( c[0] == 5 );

    e.bind( c_array, 5 );

    b.reserve( 100 );
    test_condition_( b.max_size() >= 100 );
    }


}; // namespace Massiv::Core::Test
}; // namespace Massiv::Core
}; // namespace Massiv
