/** @file test_container.h
 * Testing of all container propertise (PArray, PDictionary, PSet).
 */

/*
 * begin        : Thu Mar 11 2002
 * copyright    : (C) 2002 by Stepan Vondrak
 */

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it according to instructions in massiv/doc/licenses/source.txt.       *
 *                                                                         *
 ***************************************************************************/

#ifndef MASSIV_TEST_CONTAINER_H
#define MASSIV_TEST_CONTAINER_H


#ifndef MASSIV_COMMON_H
#include "global/common.h"
#endif

#ifndef MASSIV_TEST_H
#include "test/test.h"
#endif



namespace Massiv {
namespace Core {
namespace Test {


class ContainerTest : public Test
    {
public:

    /**
     * Constructor.
     */
    ContainerTest();

    /**
     * Destructor.
     */
    ~ContainerTest();

public:

    /**
     * Run test.
     */
    void test();

private:

    /**
     * PValueArray test.
     */
    void test_value_array();

    /**
     * PArray test.
     */
    void test_property_array();

    /**
     * PDictionary test.
     */
    void test_dictionary();

    /**
     * PSet test.
     */
    void test_set();

    }; // class ContainerTest


} // namespace Massiv::Core::Test
} // namespace Massiv::Core
} // namespace Massiv


#endif // _TEST_CONTAINER_H_
