/** @file test_dataobject.h
 * Data object test.
 */

/*
 * begin        : Tue Dec 5 2002
 * copyright    : (C) 2002 by Martin Havlista
 */

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it according to instructions in massiv/doc/licenses/source.txt.       *
 *                                                                         *
 ***************************************************************************/

#ifndef MASSIV_TEST_DATAOBJECT_H
#define MASSIV_TEST_DATAOBJECT_H


#ifndef MASSIV_COMMON_H
#include "global/common.h"
#endif

#ifndef MASSIV_TEST_H
#include "test/test.h"
#endif



namespace Massiv {
namespace Core {

// Forward declaration. 
class DataManager; 
class DataObject;

namespace Test {



class DataObjectTest : public Test
    {

public:

    /**
     * Constructor.
     */
    DataObjectTest();

    /**
     * Destructor.
     */
    ~DataObjectTest();
   
public:

    /**
     * Run test.
     */
    void test();

    /** Create file @param file_name. */
    void create_data_file
        (
        const std::string &         file_name,
        const std::string &         text
        );

    /** Create data object and test its data node path. */
    void test_data_object
        (
        DataManager &               data_manager,
        const std::string &         data_object_name,
        const std::string &         file_content
        );
    
    /** Test data object's data node path. */
    void test_data_object_node_path
        (
        DataObject *                data_object,
        const std::string &         file_content
        );
    
    }; // DataObjectTest


}; // namespace Massiv::Core::Test
}; // namespace Massiv::Core
}; // namespace Massiv


#endif // _TEST_DATAOBJECT_H_
