/** @file test_serializer.h
 * Testing of all serializers.
 * Tests properties a bit as a side effect.
 */

/*
 * begin        : Thu Feb 21 2002
 * copyright    : (C) 2002 by Stepan Vondrak
 */

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it according to instructions in massiv/doc/licenses/source.txt.       *
 *                                                                         *
 ***************************************************************************/

#ifndef MASSIV_TEST_SERIALIZER_H
#define MASSIV_TEST_SERIALIZER_H


#ifndef MASSIV_COMMON_H
#include "global/common.h"
#endif

#ifndef MASSIV_TEST_H
#include "test/test.h"
#endif



namespace Massiv {
namespace Core {
namespace Test {


class SerializerTest : public Test
    {
public:

    /**
     * Constructor.
     */
    SerializerTest();

    /**
     * Destructor.
     */
    ~SerializerTest();

public:

    /**
     * Run test.
     */
    void test();

private:

    /**
     * Tests bitstream serialization of simple types.
     */
    void test_bitstream();

    /**
     * Tests text serialiaztion of simple types.
     */
    void test_text();

    /**
     * Tests event serialialization.
     */
    void test_events();

    /**
     * Tests system messages serialization.
     */
    void test_system_messages();

    /**
     * Tests array serialization.
     */
    void test_array();

    /**
     * Tests dictionary serialization.
     */
    void test_dictionary();

    /**
     * Tests set serialization.
     */
    void test_set();

    }; // class SerializerTest


} // namespace Massiv::Core::Test
} // namespace Massiv::Core
} // namespace Massiv


#endif // MASSIV_TEST_SERIALIZER_H
