/** @file atomic_unix.cpp
 * Atomic increment/decrement implementation.
 * FIXME: This is definitly not portable: Linux/x86, GCC 3.0+. 
 * @see atomic.h
 */

/*
 * begin        : Thu Aug 28 2003
 * copyright    : (C) 2003 by Ondrej Pecta
 */

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it according to instructions in massiv/doc/licenses/source.txt.       *
 *                                                                         *
 ***************************************************************************/

#include "thread/atomic.h"

#if ( ( __GNUC__ == 4 && __GNUC_MINOR__ >= 3 ) || __GNUC__ > 4 )
#include <ext/atomicity.h>
#else
#include <bits/atomicity.h>
#endif


namespace Massiv {
namespace Core {


// CHECKME: increment/decrement should return the incremented/decremented value,
//          but __exchange_and_add returns the original value.

Int32 Atomic::increment
    (
    Int32 & value
    ) 
    {
    return __gnu_cxx::__exchange_and_add( reinterpret_cast<_Atomic_word *>( &value ), 1 ) + 1;
    }
    

Int32 Atomic::decrement
    (
    Int32 & value
    )
    {
    return __gnu_cxx::__exchange_and_add( reinterpret_cast<_Atomic_word *>( &value ), -1 ) - 1;
    }


} // namespace Massiv::Core
} // namespace Massiv
