/** @file atomic_win32.cpp
 * Atomic increment/decrement implementation.
 * @see atomic.h
 */

/*
 * begin        : Thu Aug 28 2003
 * copyright    : (C) 2003 by Ondrej Pecta
 */

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it according to instructions in massiv/doc/licenses/source.txt.       *
 *                                                                         *
 ***************************************************************************/

#include "thread/atomic.h"
#include <windows.h>


namespace Massiv {
namespace Core {


Int32 Atomic::increment
    (
    Int32 & value
    ) 
    {
    return InterlockedIncrement( reinterpret_cast<long *>( &value ) );
    }
    

Int32 Atomic::decrement
    (
    Int32 & value
    )
    {
    return InterlockedDecrement( reinterpret_cast<long *>( &value ) );
    }


} // namespace Massiv::Core
} // namespace Massiv
