/** @file synch.cpp
 * Platform-independent interface for synchronization primitives.
 * @see synch.h
 */

/*
 * begin        : Wed Oct 27 2002
 * copyright    : (C) 2002 by Marek Vondrak
 */

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it according to instructions in massiv/doc/licenses/source.txt.       *
 *                                                                         *
 ***************************************************************************/

#include "thread/synch.h"

namespace Massiv {
namespace Core {


// Implementation of CriticalSection
// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

CriticalSection::CriticalSection()
    {
    }


CriticalSection::~CriticalSection()
    {
    }


// Implementation of Lock
// ~~~~~~~~~~~~~~~~~~~~~~

Lock::Lock
    (
    CriticalSection *  section
    ) : section( section )
    {
    section->enter();
    }


Lock::~Lock()
    {
    section->leave();
    }


// Implementation of CriticalSectionManager
// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

CriticalSectionManager::CriticalSectionManager()
    {
    }


} // namespace Massiv::Core
} // namespace Massiv
