/** @file code_string.h
 * String encoding/decoding.
 */

/*
 * begin        : Wed Nov 13 2002
 * copyright    : (C) 2002 by Martin Havlista
 */

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it according to instructions in massiv/doc/licenses/source.txt.       *
 *                                                                         *
 ***************************************************************************/

#ifndef MASSIV_CODE_STRING_H
#define MASSIV_CODE_STRING_H


#ifndef MASSIV_COMMON_H
#include "global/common.h"
#endif

#include <string>


namespace Massiv {
namespace Core {


/** @addtogroup utility
 * @{
 */

/** @class CodeString
 * Obsolete class, use #quote_string() (see quote_string.h) instead.
 *
 * String coder/decoder.
 * Transforms any string to a special encoded string that does not
 * contain white spaces.
 */
class CodeString
    {
public:

    /** Encodes string. */
    static std::string encode
        (
        const std::string & str
        );

    /** Decodes encoded string. */
    static std::string decode
        (
        const std::string & str
        );

    }; // class CodeString

/** @} */ // addtogroup utility


} // namespace Massiv::Core
} // namespace Massiv


#endif // MASSIV_CODE_STRING_H
