/** @file misc_class.h
 * Miscellaneous unsorted classes.
 */

/*
 * begin        : Fri Apr 26 2002
 * copyright    : (C) 2002 by Petr Tovarys
 */

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it according to instructions in massiv/doc/licenses/source.txt.       *
 *                                                                         *
 ***************************************************************************/


#ifndef MASSIV_MISC_CLASS_H
#define MASSIV_MISC_CLASS_H


#ifndef MASSIV_COMMON_H
#include "global/common.h"
#endif

#include <functional>


namespace Massiv {
namespace Core {


/** @addtogroup utility
 * @{
 */

/** @struct EmptyStruct
 * Empty struct.
 */
struct EmptyStruct
    {
    }; // EmptyStruct


/** @struct VoidBinaryFunction
 * Empty binary functor which does nothing. Return type is @c void.
 */
template< class Data1, class Data2 >
struct VoidBinaryFunction : public std::binary_function< Data1, Data2, void >
    {
    void operator()
        (
        const Data1 &       data1,
        const Data2 &       data2
        ) const
        {
        }
    }; // VoidBinaryFunction

/** @} */ // addtogroup utility


} //namespace Massiv::Core
} //namespace Massiv


#endif // MASSIV_MISC_CLASS_H
