/** @file client_common.h
 * Common client stuff.
 *
 * @bug Including whole core.h is usually unnecessary, but including anything else
 *      may actually slow compilation down when using precompiled headers.
 */

/*
 * begin        : Sun Mar 9 2003
 * copyright    : (C) 2003 by Petr Tovarys
 */

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it according to instructions in massiv/doc/licenses/source.txt.       *
 *                                                                         *
 ***************************************************************************/

 
#ifndef CLIENT_COMMON_H
#define CLIENT_COMMON_H


// FIXME: Neither core.h nor core_base.h includes logger
#ifndef MASSIV_CORE_BASE_H
#include "core_base.h"
#endif

#ifndef MASSIV_SYSTEM_TIME_H
#include "time/system_time.h"
#endif

// The most simple vectors we have are SVector2|3.
#ifndef MASSIV_STYPE_VECTOR_H
#include "serializer/stype_vector.h"
#endif

#ifndef MASSIV_STYPE_COLOR_H
#include "serializer/stype_color.h"
#endif

#ifndef MASSIV_STYPE_ORIENTATION_H
#include "serializer/stype_orientation.h"
#endif

#ifndef MASSIV_STYPE_TIME_H
#include "serializer/stype_time.h"
#endif

#include <cstdlib>


namespace Demo {
namespace Client {


// Import some useful types.

using ::Massiv::Core::Int8;
using ::Massiv::Core::Int16;
using ::Massiv::Core::Int32;
using ::Massiv::Core::Int64;
using ::Massiv::Core::UInt8;
using ::Massiv::Core::UInt16;
using ::Massiv::Core::UInt32;
using ::Massiv::Core::UInt64;

using ::Massiv::Core::Float32;
using ::Massiv::Core::Float64;

// Note: Unfortunately it seems that "using" templates does nothing in MSVC6...
//using ::Massiv::Core::FloatTraits;

using ::Massiv::Core::SVector2;
using ::Massiv::Core::SVector3;

using ::Massiv::Core::SColor;

using ::Massiv::Core::SOrientation;

using ::Massiv::Core::STime;

using ::Massiv::Core::SystemTime;


} // namespace Client
} // namespace Demo


#endif // CLIENT_COMMON_H
