/** @file client_exception.h
 * Client exceptions.
 */

/*
 * begin        : Sun Mar 9 2003
 * copyright    : (C) 2003 by Petr Tovarys
 */

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it according to instructions in massiv/doc/licenses/source.txt.       *
 *                                                                         *
 ***************************************************************************/

 
#ifndef CLIENT_EXCEPTION_H
#define CLIENT_EXCEPTION_H

#ifndef CLIENT_COMMON_H
#include "client_common.h"
#endif

#ifndef MASSIV_CORE_H
#include "core.h"
#endif


namespace Demo {
namespace Client {


/**
 * Generic client exception.
 */
MASSIV_EXCEPTION( ExClientError, Massiv::Core::ExCommonError );

/**
 * SDL related errors.
 */
MASSIV_EXCEPTION( ExSDLError, ExClientError );
MASSIV_EXCEPTION( ExInitSDLError, ExSDLError );
MASSIV_EXCEPTION( ExOpenVideoModeError, ExSDLError );

/**
 * Renderer and OpenGL related errors.
 */
MASSIV_EXCEPTION( ExRendererError, ExClientError );
MASSIV_EXCEPTION( ExOpenGLError, ExRendererError );

/**
 * Tag database errors.
 */
MASSIV_EXCEPTION( ExTagDatabaseError, ExClientError );

/**
 * Media repository.
 */
MASSIV_EXCEPTION( ExMediaRepositoryError, ExClientError );

/**
 * Login dialog errors.
 */
MASSIV_EXCEPTION( ExBadLoginFile, ExClientError );
MASSIV_EXCEPTION( ExBadPassword, ExClientError );


} // namespace Client
} // namespace Demo


#endif // CLIENT_EXCEPTION_H
