/** @file client_global_inline.h
 * Global client stuff (inline functions).
 */

/*
 * begin        : Jun 2003
 * copyright    : (C) 2003 by Stepan Vondrak
 */

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it according to instructions in massiv/doc/licenses/source.txt.       *
 *                                                                         *
 ***************************************************************************/


namespace Demo {
namespace Client {


bool Global::is_initialized()
    {
    return objects != NULL;
    }


Renderer::Global & Global::get_renderer()
    {
    hope( objects );
    hope( objects->renderer.get() );
    return *objects->renderer;
    }


Renderer::Font & Global::get_console_font()
    {
    hope( objects );
    hope( objects->console_font.get() );
    return *objects->console_font;
    }


Renderer::TextRectangle & Global::get_message()
    {
    hope( objects );
    hope( objects->message.get() );
    return *objects->message;
    }


FullConsole & Global::get_full_console()
    {
    hope( objects );
    hope( objects->full_console.get() );
    return *objects->full_console;
    }
    
    
ChatConsole & Global::get_chat_console()
    {
    hope( objects );
    hope( objects->chat_console.get() );
    return *objects->chat_console;
    }    


Console::ConsoleSwitcher & Global::get_console_switcher()
    {
    hope( objects );
    hope( objects->console_switcher.get() );
    return *objects->console_switcher;
    }    


TagDatabase & Global::get_model_database()
    {
    hope( objects );
    hope( objects->model_database.get() );
    return *objects->model_database;
    }


PlayerManager & Global::get_player_manager()
    {
    hope( objects );
    hope( objects->player_manager.get() );
    return *objects->player_manager;
    }


SectorManager & Global::get_sector_manager()
    {
    hope( objects );
    hope( objects->sector_manager.get() );
    return *objects->sector_manager;
    }


EntityManager & Global::get_entity_manager()
    {
    hope( objects );
    hope( objects->entity_manager.get() );
    return *objects->entity_manager;
    }


Renderer::MeshEntity & Global::get_intersection_entity()
    {
    hope( objects );
    hope( objects->intersection_entity.get() );
    return *objects->intersection_entity;
    }


GameInput & Global::get_game_input()
    {
    hope( objects );
    hope( objects->game_input.get() );
    return *objects->game_input;
    }


InputManager & Global::get_input_manager()
    {
    hope( objects );
    hope( objects->input_manager.get() );
    return *objects->input_manager;
    }


GameInterface & Global::get_game_interface()
    {
    hope( objects );
    hope( objects->game_interface.get() );
    return *objects->game_interface;
    }


MediaRepository & Global::get_media_repository()
    {
    hope( objects );
    hope( objects->media_repository.get() );
    return *objects->media_repository;
    }


GameContext & Global::get_game_context()
    {
    hope( objects );
    hope( objects->game_context.get() );
    return *objects->game_context;
    }


WidgetInputDispatcher & Global::get_widget_input_dispatcher()
    {
    hope( objects );
    hope( objects->widget_input_dispatcher.get() );
    return *objects->widget_input_dispatcher;
    }


Editor & Global::get_editor()
    {
    hope( objects );
    hope( objects->editor.get() );
    return *objects->editor;
    }


TerrainWindow & Global::get_terrain_window()
    {
    hope( objects );
    hope( objects->terrain_window.get() );
    return *objects->terrain_window;
    }


} // namespace Client
} // namespace Demo
