/** @file entity_manager_inline.h
 * Manager of client entities (inline methods).
 */

/*
 * begin        : Sep 2003
 * copyright    : (C) 2003 by Stepan Vondrak
 */

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it according to instructions in massiv/doc/licenses/source.txt.       *
 *                                                                         *
 ***************************************************************************/

namespace Demo {
namespace Client {

// class EntityManager::EntityInfo::PositionTime

EntityManager::EntityInfo::PositionTime::PositionTime()
    {
    }


EntityManager::EntityInfo::PositionTime::PositionTime
    (
    const SVector2 &    the_position,
    const Time &        the_time
    ) : position( the_position ),
        time( the_time )
    {
    }

// class EntityManager::EntityInfo

EntityManager::EntityInfo::EntityInfo()
      : should_be_visible( false ),
        history_base_index( 0 ),
        history_size( 0 ),
        prediction_valid( false )
    {
    }


EntityManager::EntityInfo::~EntityInfo()
    {
    }


std::size_t EntityManager::EntityInfo::get_history_index
    (
    std::size_t index
    ) const
    {
    hope( index < history_size );
    return ( history_base_index + history_size - 1 - index ) % POSITION_HISTORY_LENGTH;
    }


// class EntityManager

const ::Massiv::Core::ObjectId & EntityManager::get_visible_layer() const
    {
    return visible_layer;
    }


} // namespace Demo::Client
} // namespace Demo
