/** @file player_manager_inline.h
 * Manager of active player entity (inline methods).
 */

/*
 * begin        : Sep 2003
 * copyright    : (C) 2003 by Stepan Vondrak
 */

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it according to instructions in massiv/doc/licenses/source.txt.       *
 *                                                                         *
 ***************************************************************************/

namespace Demo {
namespace Client {


PlayerManager::EntityPointer PlayerManager::get_player() const
    {
    return player;
    }


const SVector3 & PlayerManager::get_player_position() const
    {
    return position;
    }


const SOrientation & PlayerManager::get_player_orientation() const
    {
    return orientation;
    }

    
const PlayerManager::ObjectId & PlayerManager::get_visible_layer() const
    {
    return visible_layer_id;
    }


Renderer::CirclingCamera & PlayerManager::get_camera()
    {
    hope( camera.get() );
    return *camera;
    }


} // namespace Demo::Client
} // namespace Demo
