/** @file button_inline.cpp
 * Simple graphic button with text label (inline methods).
 */

/*
 * begin        : Aug 2003
 * copyright    : (C) 2003 by Petr Tovarys
 */

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it according to instructions in massiv/doc/licenses/source.txt.       *
 *                                                                         *
 ***************************************************************************/

namespace Demo {
namespace Client {


bool Button::is_up() const
    {
    return !down;
    }
    
    
bool Button::is_down() const
    {
    return down;
    }


void Button::push
    (
    bool    _down,
    bool    notify_receiver
    )
    {
    if( ( down && _down ) || ( !down && !_down ) )
        {
        return;
        }
    
    down = _down;
    clicked( notify_receiver );
    }


void Button::set_message_receiver
    (
    ButtonMessageReceiver * the_message_receiver
    )
    {
    message_receiver = the_message_receiver;
    }


} // namespace Demo::Client
} // namespace Demo
