/** @file chat_console.h
 * Client chat console.
 */

/*
 * begin        : Thu Mar 13 2003
 * copyright    : (C) 2003 by Marek Vondrak
 */

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it according to instructions in massiv/doc/licenses/source.txt.       *
 *                                                                         *
 ***************************************************************************/

#ifndef CLIENT_CHAT_CONSOLE_H
#define CLIENT_CHAT_CONSOLE_H

#ifndef CLIENT_COMMON_H
#include "client_common.h"
#endif

#ifndef CLIENT_CONSOLE_H
#include "gui/client_console.h"
#endif

namespace Demo {
namespace Client {

/**
 * Small chat console - ChatConsole.
 */
class ChatConsole : 
    public Console
    {
public:

    /**
     * Constructor.
     */
    ChatConsole();

public:

    // From Console.
    virtual void initialize();

private:

    // From Console.
    virtual void print_welcome();

    // From Console.
    virtual void redraw_animations
        (
        int rows
        );

    // From Console.    
    virtual bool top_border_click();
    
    // From Widget.
    virtual bool mouse_move
        (
        int     dx,
        int     dy,
        SDLMod  mod
        );

private:

    /**
     * Draws layout.
     */
    void do_layout();

private:
    
    int         chat_console_height;
        /**< Chat console height in lines. */
    
        
    }; // ChatConsole

} // namespace Client
} // namespace Demo

#endif // CLIENT_CHAT_CONSOLE_H
