/** @file client_full_console.h
 * Client full console.
 */

/*
 * begin        : Thu Mar 13 2003
 * copyright    : (C) 2003 by Marek Vondrak
 */

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it according to instructions in massiv/doc/licenses/source.txt.       *
 *                                                                         *
 ***************************************************************************/

#ifndef CLIENT_FULL_CONSOLE_H
#define CLIENT_FULL_CONSOLE_H

#ifndef CLIENT_COMMON_H
#include "client_common.h"
#endif

#ifndef CLIENT_CONSOLE_H
#include "gui/client_console.h"
#endif


namespace Demo {
namespace Client {

/**
 * Full screen console - FullConsole.
 */
class FullConsole : public Console
    {
public:

    /**
     * Constructor.
     */
    FullConsole();

public:

    // From Console.
    virtual void initialize();

private:

    // From Console.
    virtual void print_welcome();

    // From Console.
    virtual void redraw_animations
        (
        int rows
        );

    // From Console.
    virtual bool top_border_click();
    
    }; // Console

} // namespace Client
} // namespace Demo

#endif // CLIENT_FULL_CONSOLE_H
