/** @file color_string.cpp
 * Color string implementation.
 */

/*
 * begin        : Wed Sep 03 2003
 * copyright    : (C) 2003 by Ondrej Pecta
 */

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it according to instructions in massiv/doc/licenses/source.txt.       *
 *                                                                         *
 ***************************************************************************/

#include "gui/color_string.h"


namespace Demo {
namespace Client {

ColorString::ColorString()
    : string()
    {
    color_map.clear();
    color_map.insert( ColorMap::value_type( 0 , SColor( 1.0f, 1.0f, 0.5f ) ) ); 
    }


ColorString::ColorString
    (
    const std::string & str
    )
    : string( str )
    {
    color_map.clear();
    color_map.insert( ColorMap::value_type( 0 , SColor( 1.0f, 1.0f, 0.5f ) ) ); 
    }


ColorString::~ColorString()
    {
    color_map.clear();
    }

    
} // namespace Client
} // namespace Demo


#ifndef ENABLE_INLINE
#include "color_string_inline.h"
#endif
