/** @file widget_inline.h
 * Widget (inline methods).
 */

/*
 * begin        : Jul 2003
 * copyright    : (C) 2003 by Petr Tovarys
 */

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it according to instructions in massiv/doc/licenses/source.txt.       *
 *                                                                         *
 ***************************************************************************/

 
namespace Demo {
namespace Client {


bool Widget::is_focusable() const
    {
    return ::Massiv::Core::flags_on( behavior, FOCUSABLE );
    }


bool Widget::is_tab_focusable() const
    {
    return ::Massiv::Core::flags_on( behavior, TAB_FOCUSABLE );
    }


bool Widget::is_click_focusable() const
    {
    return ::Massiv::Core::flags_on( behavior, CLICK_FOCUSABLE );
    }


bool Widget::is_window_focusable() const
    {
    return ::Massiv::Core::flags_on( behavior, WINDOW_FOCUSABLE );
    }


bool Widget::is_click_lose_focus() const
    {
    return ::Massiv::Core::flags_on( behavior, CLICK_LOSE_FOCUS );
    }


Widget * Widget::get_parent() const
    {
    return parent;
    }


} // namespace Demo::Client
} // namespace Demo
