/** @file input_layers.h
 * Standard input layer indices.
 */

/*
 * begin        : Jul 2003
 * copyright    : (C) 2003 by Petr Tovarys
 */

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it according to instructions in massiv/doc/licenses/source.txt.       *
 *                                                                         *
 ***************************************************************************/

#ifndef CLIENT_INPUT_LAYERS_H
#define CLIENT_INPUT_LAYERS_H


#ifndef CLIENT_COMMON_H
#include "client_common.h"
#endif


namespace Demo {
namespace Client {


namespace InputLayers {


/**
 * Lower indices handles input events first.
 */
enum Indices
    {
    LAYER_CONSOLE       = 0,
        /**< Topmost main console layer. Probably no longer used. */
    
    LAYER_UI,
        /**< UI layer. Input handled by global WidgetInputDispatcher. */

    LAYER_GAME,
        /**< Keyboard inputs handled by GameInput. */
    
    };


} // namespace Demo::Client::InputLayers


} // namespace Demo::Client
} // namespace Demo


#endif // CLIENT_INPUT_LAYERS_H
