/** @file input_object.cpp
 * Input object (implementation).
 */

/*
 * begin        : Jul 2003
 * copyright    : (C) 2003 by Petr Tovarys
 */

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it according to instructions in massiv/doc/licenses/source.txt.       *
 *                                                                         *
 ***************************************************************************/

#include "input/input_object.h"
#include "input/input_manager.h"
#include "client_global.h"


namespace Demo {
namespace Client {


InputObject::~InputObject()
    {
    unregister_from_input_manager();
    }


void InputObject::register_to_input_manager
    (
    InputManager *  new_manager,
    int             new_layer
    )
    {
    hope( new_layer >= 0 );
    if( manager )
        {
        manager->unregister_object( this, layer );
        manager = NULL;
        layer = 0;
        }
    if( new_manager )
        {
        new_manager->register_object( this, new_layer );
        manager = new_manager;
        layer = new_layer;
        }
    }


void InputObject::register_to_global_input_manager
    (
    int new_layer
    )
    {
    InputManager & input_manager = Global::get_input_manager();
    register_to_input_manager( &input_manager, new_layer );
    }


} // namespace Demo::Client
} // namespace Demo


#ifndef ENABLE_INLINE
#include "input/input_object_inline.h"
#endif
