/** @file input_object_inline.h
 * Input object (inline methods).
 */

/*
 * begin        : Jul 2003
 * copyright    : (C) 2003 by Petr Tovarys
 */

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it according to instructions in massiv/doc/licenses/source.txt.       *
 *                                                                         *
 ***************************************************************************/

namespace Demo {
namespace Client {


InputObject::InputObject() :
    input_enabled( true ),
    manager( NULL ),
    layer( 0 )
    {
    }


bool InputObject::is_input_enabled() const
    {
    return input_enabled;
    }


void InputObject::enable_input()
    {
    enable_disable_input( true );
    }


void InputObject::disable_input()
    {
    enable_disable_input( false );
    }


void InputObject::enable_disable_input
    (
    bool enable
    )
    {
    input_enabled = enable;
    }


void InputObject::unregister_from_input_manager()
    {
    register_to_input_manager( NULL, 0 );
    }


bool InputObject::key_up
    (
    SDLKey  key,
    SDLMod  mod
    )
    {
    return false;
    }


bool InputObject::key_down
    (
    SDLKey  key,
    SDLMod  mod
    )
    {
    return false;
    }
    

bool InputObject::mouse_button_up
    (
    int     button,
    SDLMod  mod
    )
    {
    return false;
    }


bool InputObject::mouse_button_down
    (
    int     button,
    SDLMod  mod
    )
    {
    return false;
    }


bool InputObject::mouse_move
    (
    int    dx,
    int    dy,
    SDLMod mod
    )
    {
    return false;
    }


} // namespace Demo::Client
} // namespace Demo
