/** @file main.cpp
 * Client executable entry point.
 */

/*
 * begin        : Thu Feb 27 2003
 * copyright    : (C) 2003 by Petr Tovarys
 */

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it according to instructions in massiv/doc/licenses/source.txt.       *
 *                                                                         *
 ***************************************************************************/


#include "client_main.h"
#include "status/exception.h"
#include <iostream>
#include <typeinfo>


using namespace Massiv::Core;


/**
 * Main.
 */
 
// Note: 'main' is #define defined by SDL library. SDL is included
// by client_main.h file.
int main
    (
    int             argc,
    const char **   argv
    )
    {
    Demo::Client::Main client_main;
    try
        {
        client_main.run( argc, argv );
        }
    catch( Exception & exception )
        {
        std::cout << "Unhandled exception " << typeid( exception ).name() <<
            " caught:\n" << exception.what() << std::endl;
        }
    catch( ... )
        {
        std::cout << "Unhandled non-massiv exception." << std::endl;
        throw; // Let the runtime library show some info.
        }

    return 0;
    }
