/** @file font_inline.h
 * Fixed-width font (inline methods).
 */

/*
 * begin        : Jun 2003
 * copyright    : (C) 2003 by Stepan Vondrak
 */

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it according to instructions in massiv/doc/licenses/source.txt.       *
 *                                                                         *
 ***************************************************************************/

namespace Demo {
namespace Client {
namespace Renderer {


Font::CharInfo::CharInfo()
      : valid( false ),
        row( 0 ),
        column( 0 )
    {
    }


int Font::get_texture_flags()
    {
    return Texture::EXTEND_IMAGE | TextureDataObject::INTENSITY_ALPHA;
    }


int Font::get_version() const
    {
    return font_version;
    }


bool Font::is_valid
    (
    char        c
    ) const
    {
    const int index = static_cast< unsigned char >( c ) - first_character;
    if( ( index < 0 ) || ( index >= character_count ) )
        {
        return false;
        }
    return character_infos[ index ].valid;
    }


int Font::get_character_width()
    {
    return character_width;
    }


int Font::get_character_height()
    {
    return character_height;
    }


} // namespace Demo::Client::Renderer
} // namespace Demo::Client
} // namespace Demo

