/** @file layers.h
 * Standard overlay layer indices.
 */

/*
 * begin        : Jul 2003
 * copyright    : (C) 2003 by Stepan Vondrak
 */

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it according to instructions in massiv/doc/licenses/source.txt.       *
 *                                                                         *
 ***************************************************************************/

#ifndef CLIENT_LAYERS_H
#define CLIENT_LAYERS_H


#ifndef CLIENT_COMMON_H
#include "client_common.h"
#endif

#ifndef CLIENT_PASSES_H
#include "renderer/passes.h"
#endif


namespace Demo {
namespace Client {
namespace Renderer {


/**
 * Layer indices for PASS_BACKGROUND.
 */
enum BackgroundLayers
    {
    LAYER_WALLPAPER     = 0,
        /**< Wallpaper layer. */

    }; // enum BackgroundLayers


/**
 * Layer indices for PASS_UI.
 */
enum UiLayers
    {
    LAYER_UI            = 0,
        /**< Standard UI layer. */

    }; // enum UiLayers


/**
 * Layer indices for PASS_CONSOLE.
 */
enum ConsoleLayers
    {
    LAYER_CONSOLE       = 0,
        /**< Standard console layer. */

    }; // enum ConsoleLayers


/**
 * Layer indices for PASS_TOPMOST.
 */
enum TopmostLayers
    {
    LAYER_TOPMOST       = 0,
        /**< Standard topmost layer. */

    }; // enum TopmostLayers


} // namespace Demo::Client::Renderer
} // namespace Demo::Client
} // namespace Demo


#endif // CLIENT_LAYERS_H
