/** @file light_inline.h
 * Light source (inline methods).
 */

/*
 * begin        : Jul 2003
 * copyright    : (C) 2003 by Stepan Vondrak
 */

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it according to instructions in massiv/doc/licenses/source.txt.       *
 *                                                                         *
 ***************************************************************************/

namespace Demo {
namespace Client {
namespace Renderer {


const SVector3 & Light::get_position() const
    {
    return position;
    }


bool Light::is_infinite() const
    {
    return infinite;
    }


const SColor & Light::get_ambient_intensity() const
    {
    return ambient_intensity;
    }


const SColor & Light::get_diffuse_intensity() const
    {
    return diffuse_intensity;
    }


const SColor & Light::get_specular_intensity() const
    {
    return specular_intensity;
    }


const SVector3 & Light::get_attenuation() const
    {
    return attenuation;
    }


void Light::set_position
    (
    const SVector3 & new_position
    )
    {
    position = new_position;
    }


void Light::set_infinite
    (
    bool new_infinite
    )
    {
    infinite = new_infinite;
    }


void Light::set_ambient_intensity
    (
    const SColor & new_ambient_intensity
    )
    {
    ambient_intensity = new_ambient_intensity;
    }


void Light::set_diffuse_intensity
    (
    const SColor & new_diffuse_intensity
    )
    {
    diffuse_intensity = new_diffuse_intensity;
    }


void Light::set_specular_intensity
    (
    const SColor & new_specular_intensity
    )
    {
    specular_intensity = new_specular_intensity;
    }


void Light::set_attenuation
    (
    const SVector3 & new_attenuation
    )
    {
    attenuation = new_attenuation;
    }


void Light::unregister_from_manager()
    {
    register_to_manager( NULL );
    }


} // namespace Demo::Client::Renderer
} // namespace Demo::Client
} // namespace Demo
