/** @file mesh_inline.h
 * 3D triangle mesh (inline methods).
 */

/*
 * begin        : Sep 2003
 * copyright    : (C) 2003 by Stepan Vondrak
 */

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it according to instructions in massiv/doc/licenses/source.txt.       *
 *                                                                         *
 ***************************************************************************/

namespace Demo {
namespace Client {
namespace Renderer {


std::size_t Mesh::get_vertex_stream_count() const
    {
    return vertex_coordinates.size();
    }


std::size_t Mesh::get_normal_stream_count() const
    {
    return vertex_normals.size();
    }


std::size_t Mesh::get_texcoord_stream_count() const
    {
    return texture_coordinates.size();
    }


std::size_t Mesh::get_color_stream_count() const
    {
    return vertex_colors.size();
    }


std::size_t Mesh::get_vertex_count() const
    {
    return vertex_count;
    }


std::size_t Mesh::get_triangle_count() const
    {
    return triangle_count;
    }


} // namespace Demo::Client::Renderer
} // namespace Demo::Client
} // namespace Demo
