/** @file model_data_object_inline.h
 * Model data object (inline methods).
 */

/*
 * begin        : Oct 2003
 * copyright    : (C) 2003 by Stepan Vondrak
 */

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it according to instructions in massiv/doc/licenses/source.txt.       *
 *                                                                         *
 ***************************************************************************/

namespace Demo {
namespace Client {
namespace Renderer {


// class ModelDataObject::RefTraits

void ModelDataObject::RefTraits::add_reference
    (
    const ModelDataObject * ptr
    )
    {
    if( ptr )
        {
        ptr->reference_count++;
        }
    }


void ModelDataObject::RefTraits::remove_reference
    (
    ModelDataObject *       ptr
    )
    {
    if( ptr && !--ptr->reference_count )
        {
        ptr->zero_references();
        }
    }


void ModelDataObject::RefTraits::change_reference
    (
    const ModelDataObject * ptr1,
    ModelDataObject *       ptr2
    )
    {
    add_reference( ptr1 );
    remove_reference( ptr2 );
    }


// class ModelDataObject

const std::string & ModelDataObject::get_name() const
    {
    return name;
    }


bool ModelDataObject::is_dummy() const
    {
    return data_object.get() ? false : true;
    }


} // namespace Demo::Client::Renderer
} // namespace Demo::Client
} // namespace Demo
