/** @file model_md2.h
 * Quake 2 model loading.
 */

/*
 * begin        : Oct 2003
 * copyright    : (C) 2003 by Stepan Vondrak
 */

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it according to instructions in massiv/doc/licenses/source.txt.       *
 *                                                                         *
 ***************************************************************************/

#ifndef CLIENT_MODEL_MD2_H
#define CLIENT_MODEL_MD2_H


#ifndef CLIENT_COMMON_H
#include "client_common.h"
#endif

#ifndef CLIENT_MODEL_H
#include "renderer/model.h"
#endif

#include <iostream>


namespace Demo {
namespace Client {
namespace Renderer {
namespace ModelLoad {


/**
 * Detect MD2 format.
 */
bool detect_md2
    (
    ::Massiv::Core::DataObject & data_object
    );


/**
 * Load model in MD2 format.
 */
bool load_md2
    (
    Model &                         model,
    ::Massiv::Core::DataObject &    data_object
    );


} // namespace Demo::Client::ModelLoad
} // namespace Demo::Client::Renderer
} // namespace Demo::Client
} // namespace Demo


#endif // CLIENT_MODEL_MD2_H
