/** @file overlay_animation_inline.h
 * 2D object animation (inline methods).
 */

/*
 * begin        : Jun 2003
 * copyright    : (C) 2003 by Stepan Vondrak
 */

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it according to instructions in massiv/doc/licenses/source.txt.       *
 *                                                                         *
 ***************************************************************************/

namespace Demo {
namespace Client {
namespace Renderer {


// class OverlayAnimation

OverlayAnimation::OverlayAnimation()
      : prev( NULL ),
        next( NULL )
    {
    }


// class OverlayOffsetAnimation

OverlayOffsetAnimation::OverlayOffsetAnimation
    (
    const SVector2 & the_speed,
    const SVector2 & the_offset
    ) : speed( the_speed ),
        target_offset( the_offset )
    {
    }


void OverlayOffsetAnimation::set_speed
    (
    const SVector2 & new_speed
    )
    {
    speed = new_speed;
    }


void OverlayOffsetAnimation::set_target_offset
    (
    const SVector2 & new_offset
    )
    {
    target_offset = new_offset;
    }


// class OverlayOffsetDeltaAnimation

OverlayOffsetDeltaAnimation::OverlayOffsetDeltaAnimation
    (
    const SVector2 & the_offset_delta
    ) : offset_delta( the_offset_delta )
    {
    }


void OverlayOffsetDeltaAnimation::set_offset_delta
    (
    const SVector2 & new_offset_delta
    )
    {
    offset_delta = new_offset_delta;
    }


// class OverlayColorFactorAnimation

OverlayColorFactorAnimation::OverlayColorFactorAnimation
    (
    const SColor & the_speed,
    const SColor & the_factor
    ) : factor( the_factor ),
        speed( the_speed ),
        target_factor( the_factor )
    {
    }


void OverlayColorFactorAnimation::set_speed
    (
    const SColor & new_speed
    )
    {
    speed = new_speed;
    }


void OverlayColorFactorAnimation::set_factor
    (
    const SColor & new_factor
    )
    {
    target_factor = factor = new_factor;
    }


void OverlayColorFactorAnimation::set_target_factor
    (
    const SColor & new_target_factor
    )
    {
    target_factor = new_target_factor;
    }


// class OverlayMousePositionAnimation

OverlayMousePositionAnimation::OverlayMousePositionAnimation()
    {
    }
    

} // namespace Demo::Client::Renderer
} // namespace Demo::Client
} // namespace Demo

