/** @file pass_manager.cpp
 * Manager of rendering passes (implementation).
 */

/*
 * begin        : Jul 2003
 * copyright    : (C) 2003 by Stepan Vondrak
 */

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it according to instructions in massiv/doc/licenses/source.txt.       *
 *                                                                         *
 ***************************************************************************/

#include "renderer/pass_manager.h"


namespace Demo {
namespace Client {
namespace Renderer {


// class PassManager::Pass

void PassManager::Pass::render
    (
    const SystemTime & time_delta
    )
    {
    if( overlay_manager.get() )
        {
        overlay_manager->render( time_delta );
        }
    if( render_manager.get() )
        {
        render_manager->render( time_delta );
        }
    }


// class PassManager

PassManager::PassManager()
    {
    }


PassManager::~PassManager()
    {
    }


void PassManager::render
    (
    const SystemTime & time_delta
    )
    {
    Pass::Map::iterator it;
    for( it = passes.begin(); it != passes.end(); ++it )
        {
        Pass & pass = it->second;
        pass.render( time_delta );
        }
    }


} // namespace Demo::Client::Renderer
} // namespace Demo::Client
} // namespace Demo


#ifndef ENABLE_INLINE
#include "pass_manager_inline.h"
#endif
