/** @file passes.h
 * Standard pass indices.
 */

/*
 * begin        : Jul 2003
 * copyright    : (C) 2003 by Stepan Vondrak
 */

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it according to instructions in massiv/doc/licenses/source.txt.       *
 *                                                                         *
 ***************************************************************************/

#ifndef CLIENT_PASSES_H
#define CLIENT_PASSES_H


#ifndef CLIENT_COMMON_H
#include "client_common.h"
#endif


namespace Demo {
namespace Client {
namespace Renderer {


/**
 * Standard pass indices.
 *
 * Use values from this enum as arguments to #PassManager methods.
 */
enum Passes
    {
    PASS_BACKGROUND     = 0,
        /**< Background stuff. */

    PASS_WORLD          = 10,
        /**< World entities. */
        
    PASS_CHAT_CONSOLE   = 15,
        /**< ChatConsole overlay. */

    PASS_UI             = 20,
        /**< User interface overlay. */
    
    PASS_CONSOLE        = 30,
        /**< Console overlay. */

    PASS_TOPMOST        = 40,
        /**< Topmost stuff. */

    }; // enum Passes


} // namespace Demo::Client::Renderer
} // namespace Demo::Client
} // namespace Demo


#endif // CLIENT_PASSES_H
