/** @file render_entity_inline.h
 * Generic 3D renderable entity (inline methods).
 */

/*
 * begin        : Jul 2003
 * copyright    : (C) 2003 by Stepan Vondrak
 */

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it according to instructions in massiv/doc/licenses/source.txt.       *
 *                                                                         *
 ***************************************************************************/

namespace Demo {
namespace Client {
namespace Renderer {


bool RenderEntity::is_visible() const
    {
    return visible;
    }


const SVector3 & RenderEntity::get_position() const
    {
    return position;
    }

    
const SOrientation & RenderEntity::get_orientation() const
    {
    return orientation;
    }

    
const SVector3 & RenderEntity::get_scale() const
    {
    return scale;
    }

    
void RenderEntity::set_visible
    (
    bool new_visible
    )
    {
    visible = new_visible;
    }


void RenderEntity::set_position
    (
    const SVector3 & new_position
    )
    {
    position = new_position;
    }

    
void RenderEntity::set_orientation
    (
    const SOrientation & new_orientation
    )
    {
    orientation = new_orientation;
    }

    
void RenderEntity::set_scale
    (
    const SVector3 & new_scale
    )
    {
    scale = new_scale;
    }


void RenderEntity::unregister_from_manager()
    {
    register_to_manager( NULL );
    }


} // namespace Demo::Client::Renderer
} // namespace Demo::Client
} // namespace Demo
