/** @file render_manager_inline.h
 * Manager and renderer of 3D render entities (inline methods).
 */

/*
 * begin        : Jul 2003
 * copyright    : (C) 2003 by Stepan Vondrak
 */

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it according to instructions in massiv/doc/licenses/source.txt.       *
 *                                                                         *
 ***************************************************************************/

namespace Demo {
namespace Client {
namespace Renderer {


bool RenderManager::is_lighting() const
    {
    return lighting;
    }


void RenderManager::set_lighting
    (
    bool new_lighting
    )
    {
    lighting = new_lighting;
    }


void RenderManager::set_camera
    (
    Camera * new_camera
    )
    {
    camera = new_camera;
    }

    
void RenderManager::register_entity
    (
    RenderEntity * entity
    )
    {
    hope( entity );
    hope( entities.find( entity ) == entities.end() );
    entities.insert( entity );
    }


void RenderManager::unregister_entity
    (
    RenderEntity * entity
    )
    {
    hope( entity );
    hope( entities.find( entity ) != entities.end() );
    entities.erase( entity );
    }


void RenderManager::register_light
    (
    Light * light
    )
    {
    hope( light );
    lights.push_back( light );
    }


void RenderManager::unregister_light
    (
    Light * light
    )
    {
    hope( light );
    lights.remove( light );
    }


} // namespace Demo::Client::Renderer
} // namespace Demo::Client
} // namespace Demo

