/** @file renderer_fwd.h
 * Renderer forward declarations.
 */

/*
 * begin        : Jun 2003
 * copyright    : (C) 2003 by Stepan Vondrak
 */

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it according to instructions in massiv/doc/licenses/source.txt.       *
 *                                                                         *
 ***************************************************************************/


#ifndef CLIENT_RENDERER_FWD_H
#define CLIENT_RENDERER_FWD_H


#include "client_common.h"


namespace Demo {
namespace Client {
namespace Renderer {


/**
 * Maximum number of texture units used by the renderer.
 */
enum
    {
    MAX_TEXTURE_UNITS = 2
    };


/**
 * Maximum number of OpenGL light sources used by the renderer.
 */
enum
    {
    MAX_LIGHT_SOURCES = 8
    };


// camera.h

class Camera;
class CirclingCamera;

// font.h

class Font;

// icon.h

class Icon;

// light.h

class Light;

// mesh.h

class Mesh;

// mesh_entity.h

class MeshEntity;

// model.h

class Model;

// model_data_object.h

class ModelDataObject;

// model_entity.h

class ModelEntity;

// model_manager.h

class ModelManager;

// overlay_animation.h

class OverlayAnimation;
class OverlayOffsetAnimation;
class OverlayColorFactorAnimation;

// overlay_manager.h

class OverlayManager;

// overlay_object.h

class OverlayObject;

// pass_manager.h

class PassManager;

// pipeline_state.h

class PipelineState;

// render_entity.h

class RenderEntity;

// render_manager.h

class RenderManager;

// render_object.h

class RenderObject;

// renderer.h

class Global;

// simple_entity.h

class SimpleEntity;

// terrain.h

class Heightmap;
class Terrain;

// terrain_material.h

class TerrainMaterial;
class TerrainMaterialDatabase;

// terrain_settings.h

class TerrainSettings;

// text_rectangle.h

class TextRectangle;

// texture.h

class Texture;

// texture_data_object.h

class TextureDataObject;

// texture_manager.h

class TextureManager;

// vertex_array.h

class VertexArray;


} // namespace Renderer
} // namespace Client
} // namespace Demo


#endif // CLIENT_RENDERER_FWD_H
