/** @file renderer_inline.h
 * Renderer global objects (inline methods).
 */

/*
 * begin        : Jun 2003
 * copyright    : (C) 2003 by Stepan Vondrak
 */

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it according to instructions in massiv/doc/licenses/source.txt.       *
 *                                                                         *
 ***************************************************************************/

namespace Demo {
namespace Client {
namespace Renderer {


Global & Global::get()
    {
    hope( self );
    return *self;
    }


const PipelineState & Global::get_pipeline_state()
    {
    hope( self );
    hope( self->pipeline_state.get() );
    return *self->pipeline_state;
    }


PipelineState & Global::get_overlay_pipeline_state()
    {
    hope( self );
    hope( self->overlay_pipeline_state.get() );
    return *self->overlay_pipeline_state;
    }


TextureManager & Global::get_texture_manager()
    {
    hope( self );
    hope( self->texture_manager.get() );
    return *self->texture_manager;
    }


ModelManager & Global::get_model_manager()
    {
    hope( self );
    hope( self->model_manager.get() );
    return *self->model_manager;
    }


PassManager & Global::get_pass_manager()
    {
    hope( self );
    hope( self->pass_manager.get() );
    return *self->pass_manager;
    }


TerrainMaterialDatabase & Global::get_terrain_material_database()
    {
    hope( self );
    hope( self->terrain_material_database.get() );
    return *self->terrain_material_database;
    }


TerrainSettings & Global::get_terrain_settings()
    {
    hope( self );
    hope( self->terrain_settings.get() );
    return *self->terrain_settings;
    }


} // namespace Demo::Client::Renderer
} // namespace Demo::Client
} // namespace Demo
