/** @file texture_data_object_inline.h
 * Texture data object (inline methods).
 */

/*
 * begin        : Jun 2003
 * copyright    : (C) 2003 by Stepan Vondrak
 */

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it according to instructions in massiv/doc/licenses/source.txt.       *
 *                                                                         *
 ***************************************************************************/

namespace Demo {
namespace Client {
namespace Renderer {


void TextureDataObject::RefTraits::add_reference
    (
    const TextureDataObject *   ptr
    )
    {
    if( ptr )
        {
        ptr->reference_count++;
        }
    }


void TextureDataObject::RefTraits::remove_reference
    (
    TextureDataObject *         ptr
    )
    {
    if( ptr && !--ptr->reference_count )
        {
        ptr->zero_references();
        }
    }


void TextureDataObject::RefTraits::change_reference
    (
    const TextureDataObject *   ptr1,
    TextureDataObject *         ptr2
    )
    {
    add_reference( ptr1 );
    remove_reference( ptr2 );
    }


int TextureDataObject::get_version() const
    {
    return version;
    }


int TextureDataObject::texture_index
    (
    int flags
    )
    {
    int index = 0;
    if( flags & Texture::GENERATE_MIPMAPS )
        {
        index |= 0x01;
        }
    if( flags & Texture::EXTEND_IMAGE )
        {
        index |= 0x02;
        }
    if( flags & INTENSITY_ALPHA )
        {
        index |= 0x04;
        }
    hope( index < TEXTURE_COUNT );
    return index;
    }


} // namespace Demo::Client::Renderer
} // namespace Demo::Client
} // namespace Demo
