/** @file texture_inline.h
 * Simple OpenGL texture (inline methods).
 */

/*
 * begin        : Jun 2003
 * copyright    : (C) 2003 by Stepan Vondrak
 */

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it according to instructions in massiv/doc/licenses/source.txt.       *
 *                                                                         *
 ***************************************************************************/

namespace Demo {
namespace Client {
namespace Renderer {


int Texture::get_width() const
    {
    return width;
    }


int Texture::get_height() const
    {
    return height;
    }


int Texture::get_valid_width() const
    {
    return valid_width;
    }


int Texture::get_valid_height() const
    {
    return valid_height;
    }


bool Texture::has_alpha() const
    {
    return alpha;
    }


bool Texture::has_mipmaps() const
    {
    return mipmaps;
    }


GLuint Texture::get_handle() const
    {
    return handle;
    }


Texture::Filter Texture::get_filter() const
    {
    return filter;
    }


} // namespace Demo::Client::Renderer
} // namespace Demo::Client
} // namespace Demo

