/** @file texture_manager_inline.h
 * Texture manager (inline methods).
 */

/*
 * begin        : Jun 2003
 * copyright    : (C) 2003 by Stepan Vondrak
 */

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it according to instructions in massiv/doc/licenses/source.txt.       *
 *                                                                         *
 ***************************************************************************/

namespace Demo {
namespace Client {
namespace Renderer {


int TextureManager::get_max_texture_size() const
    {
    return max_texture_size;
    }


int TextureManager::get_texture_units() const
    {
    return texture_units;
    }


int TextureManager::get_active_texture_unit() const
    {
    return active_texture_unit;
    }


Texture::Reference TextureManager::get_bound_texture() const
    {
    return bound_textures[ active_texture_unit ];
    }


void TextureManager::unbind_texture()
    {
    bind_texture( NULL );
    }


} // namespace Demo::Client::Renderer
} // namespace Demo::Client
} // namespace Demo

