/** @file stream_rwops.h
 * IOStream SDL_RWops.
 */

/*
 * begin        : Jun 2003
 * copyright    : (C) 2003 by Stepan Vondrak
 */

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it according to instructions in massiv/doc/licenses/source.txt.       *
 *                                                                         *
 ***************************************************************************/

#ifndef CLIENT_STREAM_RWOPS_H
#define CLIENT_STREAM_RWOPS_H


#ifndef CLIENT_COMMON_H
#include "client_common.h"
#endif

#include <iostream>
#include <SDL_rwops.h>


namespace Demo {
namespace Client {
namespace SDL {


/**
 * Create new stream rwops structure.
 *
 * It's assumed that @a stream does not throw exceptions on fail and eof.
 * Stream will @b not be closed when RWops is closed.
 */
SDL_RWops * create_stream_rwops
    (
    std::istream & stream
    );


} // namespace Demo::Client::SDL
} // namespace Demo::Client
} // namespace Demo


#endif // CLIENT_STREAM_RWOPS_H
