/** @file tag_database_inline.h
 * Database of string tags and tag matching (inline methods).
 */

/*
 * begin        : Oct 2003
 * copyright    : (C) 2003 by Stepan Vondrak
 */

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it according to instructions in massiv/doc/licenses/source.txt.       *
 *                                                                         *
 ***************************************************************************/

namespace Demo {
namespace Client {


// class TagSet

TagSet::TagSet()
    {
    }


TagSet::TagSet
    (
    const TagSet & other
    ) : Super( other )
    {
    }


TagSet & TagSet::operator=
    (
    const TagSet & other
    )
    {
    Super::operator=( other );
    return *this;
    }


// class TagDatabase::Mapping

TagDatabase::Mapping::Mapping()
    {
    }


TagDatabase::Mapping::Mapping
    (
    const TagSet &  the_key,
    const Strings & the_values
    ) : key( the_key ),
        values( the_values )
    {
    }


// class TagDatabase

std::size_t TagDatabase::get_value_count() const
    {
    return value_count;
    }


TagDatabase::Match TagDatabase::mappings_end() const
    {
    return mappings.end();
    }

    
bool TagDatabase::match_found
    (
    Match mapping_iterator
    ) const
    {
    return ( mapping_iterator != mappings_end() );
    }

    
} // namespace Demo::Client
} // namespace Demo

