/** @file boots.cpp
 * Boots (implementation).
 */

/*
 * begin        : Aug 2003
 * copyright    : (C) 2003 by Petr Tovarys
 */

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it according to instructions in massiv/doc/licenses/source.txt.       *
 *                                                                         *
 ***************************************************************************/

#include "core.h"
#include "lib/server/boots.h"
#include "lib/server/monster.h"
#include "lib/server/player.h"


namespace Demo {
namespace Lib {


void Boots::initialize
    (
    BootsType the_boots_type
    )
    {
    // Initialize Item class.
    Item::initialize();
    client_item->item_type = ITEM_BOOTS;
    client_item->item_variant = the_boots_type;
    client_item->equip_type = EQUIP_BOOTS;
    }


Pointer< Item > Boots::equip
    (
    Pointer< Monster > monster
    )
    {
    switch( client_item->item_variant )
        {
        case BOOTS_SPEED:
            monster->apply_powerup( ABILITY_SPEED,
                30, 30, Entity::POWERUP_PERMANENT, STime() );
            break;
        }
    
    if( monster->is_player() )
        {
        Pointer< Player > player = monster.convert();
        player->log_game_message( "You feel faster than light..." );
        }
    
    return this;
    }


Pointer< Item > Boots::unequip
    (
    Pointer< Monster > monster
    )
    {
    switch( client_item->item_variant )
        {
        case BOOTS_SPEED:
            monster->apply_powerup( ABILITY_SPEED,
                0, -30, Entity::POWERUP_PERMANENT, STime() );
            break;
        }
    
    if( monster->is_player() )
        {
        Pointer< Player > player = monster.convert();
        player->log_game_message( "You feel slower than a snail..." );
        }
    
    return this;
    }


} // namespace Demo::Lib
} // namespace Demo
