/** @file entity_test.h
 * Entity test.
 */

/*
 * begin        : Mon June 13 2003
 * copyright    : (C) 2003 by Martin Havlista
 */

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it according to instructions in massiv/doc/licenses/source.txt.       *
 *                                                                         *
 ***************************************************************************/

#ifndef DEMO_ENTITY_TEST_H
#define DEMO_ENTITY_TEST_H

#ifndef DEMO_LIB_H
#include "lib/shared/lib.h"
#endif

namespace Demo {
namespace Lib {

INJECT_CORE_SYMBOLS();


class Vertex : public ::Massiv::Core::Object
    {
public:
        
    typedef PArray< PWeakPointer<Vertex> > VertexList;
    typedef PArray< PPointer<Vertex> > NeighborList;

    static void create();

    void initialize();

    void change_edges();

public:

    VertexList      all_vertices;
    NeighborList    neighbors;
    };

class EntityTest
    {
public:

    static void test();
    static void generator_test();
    static void sector_test();
    static void area_test();

    };

} // namespace Demo::Lib
} // namespace Demo

#endif // DEMO_ENTITY_TEST_H
