/** @file garbage.cpp
 * Garbage (implementation).
 */

/*
 * begin        : Aug 2003
 * copyright    : (C) 2003 by Petr Tovarys, Stepan Vondrak
 */

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it according to instructions in massiv/doc/licenses/source.txt.       *
 *                                                                         *
 ***************************************************************************/

#include "core.h"
#include "lib/server/garbage.h"
#include "lib/server/player.h"

namespace Demo {
namespace Lib {


void Garbage::initialize
    (
    GarbageType the_garbage_type
    )
    {
    // Initialize Item class.
    Item::initialize();
    client_item->item_type = ITEM_GARBAGE;
    client_item->item_variant = the_garbage_type;
    }


Pointer< Item > Garbage::use_on_monster
    (
    Pointer< Player >       player,
    WeakPointer< Monster >  monster
    )
    {

    if( player == monster )
        {
        std::string action;
        if( client_item->item_variant == GARBAGE_FLASK )
            {
            action = "dring from";
            }
        else if( client_item->item_variant == GARBAGE_BONE )
            {
            action = "eat";
            }
        else
            {
            action = "use";
            }
        player->say( std::string( "tries to " ) + action + " " + client_item->get_long_name(), Player::MESSAGE_ACTION );
        }
    else
        {
        std::string message = "tries to use ";
        message += client_item->get_long_name();
        message += " on ";
        if( monster.is_local() )
            {
            message += monster->get_name();
            }
        else
            {
            message += "an entity";
            }
        player->say( message, Player::MESSAGE_ACTION );
        }

    return this;
    }


Pointer< Item > Garbage::use_on_sector
    (
    Pointer< Player > player
    )
    {
    // Discard the garbage.

    player->say( std::string( "throws " ) + client_item->get_long_name() + " away", Player::MESSAGE_ACTION  );
    return null;
    }


} // namespace Demo::Lib
} // namespace Demo
