/** @file garbage.h
 * Garbage items.
 */

/*
 * begin        : Aug 2003
 * copyright    : (C) 2003 by Petr Tovarys, Stepan Vondrak
 */

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it according to instructions in massiv/doc/licenses/source.txt.       *
 *                                                                         *
 ***************************************************************************/

#ifndef DEMO_GARBAGE_H
#define DEMO_GARBAGE_H


#ifndef DEMO_LIB_H
#include "lib/shared/lib.h"
#endif

#ifndef DEMO_SERVER_FWD_H
#include "lib/server/server_fwd.h"
#endif

#ifndef DEMO_CLIENT_ITEM_H
#include "lib/shared/client_item.h"
#endif

#ifndef DEMO_ITEM_H
#include "lib/server/item.h"
#endif


namespace Demo {
namespace Lib {

INJECT_CORE_SYMBOLS();


/**
 * Garbage item.
 */
class Garbage : public Item
    {
public:

    /** Initialize the object. */
    void initialize
        (
        GarbageType the_garbage_type
        );

public:

    // From Item.
    virtual Pointer< Item > use_on_monster
        (
        Pointer< Player >         player,
        WeakPointer< Monster >    monster
        );

    virtual Pointer< Item > use_on_sector
        (
        Pointer< Player > player
        );

    }; // Garbage


} // namespace Demo::Lib
} // namespace Demo

#endif // DEMO_GARBAGE_H
