/** @file lamp.cpp
 * Lamp (implementation).
 */

/*
 * begin        : Wed Aug 27 2003
 * copyright    : (C) 2003 by Ondrej Pecta
 */

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it according to instructions in massiv/doc/licenses/source.txt.       *
 *                                                                         *
 ***************************************************************************/

#include "core.h"
#include "lib/server/lamp.h"
#include "lib/shared/client_light.h"
#include "lib/shared/client_entity.h"


namespace Demo {
namespace Lib {


void Lamp::initialize()
    {
    Device::initialize();
    create_light();
    Pointer< ClientLight > l = get_light();
    l->set_offset( SVector3( 0.0f, 0.0f, 1.0f ) );
    l->set_attenuation( SVector3( 0.5f, 0.1f, 0.0f ) );
    l->set_diffuse_intensity( SColor( 1.0f, 1.0f, 1.0f ) );

    client_entity->type = ClientEntity::TYPE_LAMP;
    }
    

void Lamp::operate_synced
    (
    const STime & delivery_time
    )
    {
    Pointer<ColorPacket> packet = get_input().convert();
    get_light()->set_diffuse_intensity( packet->get_color().read() );
    }


} // namespace Demo::Lib
} // namespace Demo
