/** @file lamp.h
 * Logic device controlling entity light source parameters.
 */

/*
 * begin        : Wed Aug 27 2003
 * copyright    : (C) 2003 by Ondrej Pecta
 */

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it according to instructions in massiv/doc/licenses/source.txt.       *
 *                                                                         *
 ***************************************************************************/

#ifndef DEMO_LAMP_H
#define DEMO_LAMP_H

#ifndef DEMO_LIB_H
#include "lib/shared/lib.h"
#endif

#ifndef DEMO_SERVER_FWD_H
#include "lib/server/server_fwd.h"
#endif

#ifndef DEMO_DEVICE_H
#include "lib/server/device.h"
#endif


namespace Demo {
namespace Lib {

INJECT_CORE_SYMBOLS();


/**
 * Lamp is a device which has one default input - diffuse_intensity.
 * Other intensities are not supported yet.
 */
class Lamp : public Device
    {
public:

    MASSIV_OBJECT( Lamp );
   
    /**
     * Initializes device, creates ClientLight object.
     */
    void initialize();
    
    /**
     * Lamp logic implemetation.
     */
    void operate_synced
        (
        const STime & delivery_time
        );

    }; // Lamp


} // namespace Demo::Lib
} // namespace Demo

#endif // DEMO_LAMP_H
