/** @file lock_inline.h
 * Lock inline implementation.
 */

/*
 * begin        : Tue Nov 11 2003
 * copyright    : (C) 2003 by Marek Vondrak
 */

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it according to instructions in massiv/doc/licenses/source.txt.       *
 *                                                                         *
 ***************************************************************************/

namespace Demo {
namespace Lib {


OptimisticLock::OptimisticLock
    (
    PBool &         locked,
    const char *    message
    ) : locked( locked )
    {
    if( locked == true )
        {
        if( message != NULL )
            {
            throw LockErrorException( message );
            }
        else
            {
            panic( "Can not obtain the lock." );
            }
        }

    locked = true;
    }


OptimisticLock::~OptimisticLock()
    {
    locked = false;
    }
        

} // namespace Demo::Lib
} // namespace Demo
