/** @file server_node.h
 * Server node object.
 */

/*
 * begin        : Mon Mar 17 2003
 * copyright    : (C) 2003 by Marek Vondrak
 */

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it according to instructions in massiv/doc/licenses/source.txt.       *
 *                                                                         *
 ***************************************************************************/

#ifndef DEMO_SERVER_NODE_H
#define DEMO_SERVER_NODE_H


#ifndef DEMO_LIB_H
#include "lib/shared/lib.h"
#endif

#ifndef DEMO_SERVER_NODE_INTERFACE_H
#include "lib/shared/server_node_interface.h"
#endif


namespace Demo {
namespace Lib {

INJECT_CORE_SYMBOLS();


/**
 * NodeObject for a server node.
 */
class ServerNode : public ServerNodeInterface
    {
public:

    //
    // NodeObjectInterface implementation.
    //

    /**
     * Initializes object.
     */
    void initialize();

public:

    // From NodeObjectInterface.
    virtual NodeType get_node_type() const;


    // From NodeObjectInterface.
    virtual Pointer< Massiv::Core::Lib::AccountObjectInterface > create_account_object();
    
    }; // ServerNode

} // namespace Demo::Lib
} // namespace Demo

#endif // DEMO_SERVER_NODE_H
