/** @file teleport.cpp
 * Teleport implementation.
 */

/*
 * begin        : Mon Sep 1 2003
 * copyright    : (C) 2003 by Marek Vondrak
 */

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it according to instructions in massiv/doc/licenses/source.txt.       *
 *                                                                         *
 ***************************************************************************/

#include "core.h"
#include "lib/server/teleport.h"
#include "lib/server/physical.h"
#include "lib/server/physical_rpc.h"
#include "lib/shared/random.h"

namespace Demo {
namespace Lib {

INJECT_CORE_SYMBOLS();


void Teleport::initialize()
    {
    initialize( ConvexArea( SVector2(), SVector2( 10.0f, 10.0f ) ), 
        Entity::MONSTER );
    }


void Teleport::initialize
    (
    const ConvexArea &  the_area,
    int                 the_entity_flags
    )
    {
    Area::initialize( the_area, the_entity_flags );
    }


void Teleport::add_target
    (
    const EntityPosition & target
    )
    {
    targets.push_back( target );
    }


void Teleport::entered
    (
    WeakPointer<Physical> visitor
    )
    {
    Remote<Physical> physical = visitor;
    std::size_t i = Random::random_integer( targets.size() - 1 );

    physical->async_teleport_to( targets[ i ] );
    }


} // namespace Demo::Lib
} // namespace Demo
