/** @file weapon.h
 * Weapon items.
 */

/*
 * begin        : Aug 2003
 * copyright    : (C) 2003 by Petr Tovarys, Stepan Vondrak
 */

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it according to instructions in massiv/doc/licenses/source.txt.       *
 *                                                                         *
 ***************************************************************************/

#ifndef DEMO_WEAPON_H
#define DEMO_WEAPON_H


#ifndef DEMO_LIB_H
#include "lib/shared/lib.h"
#endif

#ifndef DEMO_SERVER_FWD_H
#include "lib/server/server_fwd.h"
#endif

#ifndef DEMO_CLIENT_ITEM_H
#include "lib/shared/client_item.h"
#endif

#ifndef DEMO_ITEM_H
#include "lib/server/item.h"
#endif


namespace Demo {
namespace Lib {

INJECT_CORE_SYMBOLS();


/**
 * Any weapon.
 */
class Weapon : public Item
    {
public:

    /** Initialize the object. */
    void initialize
        (
        WeaponType the_weapon_type
        );

public:

    // From Item.
    virtual Pointer< Item > use_on_monster
        (
        Pointer< Player >      player,
        WeakPointer< Monster > monster
        );

    }; // Weapon


} // namespace Demo::Lib
} // namespace Demo

#endif // DEMO_WEAPON_H
