/** @file world.cpp
 * World implementation.
 */

/*
 * begin        : Mon Jun 31 2003
 * copyright    : (C) 2003 by Marek Vondrak
 */

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it according to instructions in massiv/doc/licenses/source.txt.       *
 *                                                                         *
 ***************************************************************************/

#include "core.h"
#include "lib/server/world.h"
#include "lib/server/layer.h"
#include "lib/shared/list_container.h"


namespace Demo {
namespace Lib {

INJECT_CORE_SYMBOLS();


// Implementation of World
// ~~~~~~~~~~~~~~~~~~~~~~~

void World::initialize()
    {
    layer_list = CreateObject<List>();
    }


void World::register_layer
    (
    Pointer<Layer> layer
    )
    {
    hope( layer->world == null );

    layer_list->push_front( layer.convert() );
    
    layer->world = this;
    layer->layer_list_enumerator = layer_list->begin();
    }


void World::unregister_layer
    (
    Pointer<Layer> layer
    )
    {
    hope( layer->world == this );
    
    layer->world = null;
    layer->layer_list_enumerator->erase();
    layer->layer_list_enumerator = null;
    }


} // namespace Demo::Lib
} // namespace Demo
