/** @file ability.cpp
 * Ability (implementation).
 */

/*
 * begin        : Aug 2003
 * copyright    : (C) 2003 by Petr Tovarys
 */

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it according to instructions in massiv/doc/licenses/source.txt.       *
 *                                                                         *
 ***************************************************************************/

#include "core.h"
#include "lib/shared/ability.h"


namespace Demo {
namespace Lib {


Ability::Ability()
    {
    initialize_object();
    default_constructed();
    }


Ability::Ability
    (
    Int32   the_value,
    Int32   the_upper_limit
    ) :
    value( the_value ),
    upper_limit( the_upper_limit )
    {
    initialize_object();
    }


Ability::Ability
    (
    const Ability & other
    ) :
    ValueType( other ),
    value( other.value ),
    upper_limit( other.upper_limit )
    {
    initialize_object();
    }


void Ability::set_value
    (
    Int32   new_value
    )
    {
    value = new_value;
    if( value > upper_limit )
        {
        value = upper_limit;
        }
    else if( value < 0 )
        {
        value = 0;
        }
    }


void Ability::add_value
    (
    Int32   delta
    )
    {
    set_value( value + delta );
    }


void Ability::set_upper_limit
    (
    Int32   new_upper_limit
    )
    {
    upper_limit = new_upper_limit;
    if( upper_limit < 0 )
        {
        upper_limit = 0;
        }
    if( value > upper_limit )
        {
        value = upper_limit;
        }
    }


void Ability::add_upper_limit
    (
    Int32   delta
    )
    {
    set_upper_limit( upper_limit + delta );
    }


} // namespace Demo::Lib
} // namespace Demo
