/** @file client_item_slot_container.cpp
 * ClientItemSlotContainer (implementation).
 */

/*
 * begin        : Tue Aug 5 2003
 * copyright    : (C) 2003 by Petr Tovarys
 */

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it according to instructions in massiv/doc/licenses/source.txt.       *
 *                                                                         *
 ***************************************************************************/

#include "core.h"
#include "lib/shared/client_item_slot_container.h"


namespace Demo {
namespace Lib {


void ClientItemSlotContainer::initialize
    (
    int the_slot_columns,
    int the_slot_rows
    )
    {
    hope( the_slot_columns > 0 && the_slot_rows > 0 );
    
    slot_columns = the_slot_columns;
    slot_rows    = the_slot_rows;
    
    slots.resize( the_slot_columns * the_slot_rows );
    }


bool ClientItemSlotContainer::is_valid_slot_index
    (
    int slot_index
    ) const
    {
    hope( slots.size() == static_cast< std::size_t >( slot_columns * slot_rows ) );
    return ( slot_index >= 0 && ( slot_index < ( slot_columns * slot_rows ) ) );
    }


} // namespace Demo::Lib
} // namespace Demo
