/** @file client_item_slot_container.h
 * ClientItemSlotContainer.
 */

/*
 * begin        : Tue Aug 5 2003
 * copyright    : (C) 2003 by Petr Tovarys
 */

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it according to instructions in massiv/doc/licenses/source.txt.       *
 *                                                                         *
 ***************************************************************************/

#ifndef DEMO_CLIENT_ITEM_SLOT_CONTAINER_H
#define DEMO_CLIENT_ITEM_SLOT_CONTAINER_H


#ifndef DEMO_LIB_H
#include "lib/shared/lib.h"
#endif

#ifndef DEMO_SHARED_FWD_H
#include "lib/shared/shared_fwd.h"
#endif


namespace Demo {
namespace Lib {

INJECT_CORE_SYMBOLS();


/**
 * Client visible part of item slot container.
 */
class ClientItemSlotContainer : public Object
    {
public:
    
    MASSIV_OBJECT( ClientItemSlotContainer );

    /** Array of slots. */
    typedef PArray< PPointer< ClientItem > >  Slots;
    
public:

    /** Initializes the slot container. */
    void initialize
        (
        int slot_columns,
        int slot_rows
        );

public:

    /**
     * Check whether @a slot_index is valid slot index
     * into @a slots array.
     */
    bool is_valid_slot_index
        (
        int slot_index
        ) const;

public:
    
    PVlInt32        slot_columns;
        /**< Number of columns in the container. */
    PVlInt32        slot_rows;
        /**< Number of rows in the container. */
    Slots           slots;
        /**< Array of slots. */
    
    }; // ClientItemSlotContainer


} // namespace Demo::Lib
} // namespace Demo

#endif // DEMO_CLIENT_ITEM_SLOT_CONTAINER_H
