/** @file client_light.cpp
 * Optional ClientEntity light source parameters (implementation).
 */

/*
 * begin        : Nov 2003
 * copyright    : (C) 2003 by Ondrej Pecta, Stepan Vondrak
 */

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it according to instructions in massiv/doc/licenses/source.txt.       *
 *                                                                         *
 ***************************************************************************/

#include "core.h"
#include "lib/shared/client_light.h"


namespace Demo {
namespace Lib {


void ClientLight::initialize()
    {
    ambient_intensity = PColor( 0.0f, 0.0f, 0.0f );
    diffuse_intensity = PColor( 1.0f, 1.0f, 1.0f );
    specular_intensity = PColor( 1.0f, 1.0f, 1.0f );
    attenuation = PVector3( 1.0f, 0.0f, 0.0f );
    }

const SVector3 ClientLight::get_offset() const
    {
    return offset.read();
    }


const SColor ClientLight::get_ambient_intensity() const
    {
    return ambient_intensity.read();
    }


const SColor ClientLight::get_diffuse_intensity() const
    {
    return diffuse_intensity.read();
    }


const SColor ClientLight::get_specular_intensity() const
    {
    return specular_intensity.read(); 
    }


const SVector3 ClientLight::get_attenuation() const
    {
    return attenuation.read();
    }


void ClientLight::set_offset
    (
    const SVector3 new_offset
    )
    {
    offset = new_offset;
    }


void ClientLight::set_ambient_intensity
    (
    const SColor new_ambient_intensity
    )
    {
    ambient_intensity = new_ambient_intensity.read();
    }


void ClientLight::set_diffuse_intensity
    (
    const SColor new_diffuse_intensity
    )
    {
    diffuse_intensity = new_diffuse_intensity.read();
    }


void ClientLight::set_specular_intensity
    (
    const SColor new_specular_intensity
    )
    {
    specular_intensity = new_specular_intensity.read();
    }


void ClientLight::set_attenuation
    (
    const SVector3 new_attenuation
    )
    {
    attenuation = new_attenuation;
    }


} // namespace Demo::Lib
} // namespace Demo
