/** @file game_defs.h
 * Common game definitions.
 */

/*
 * begin        : Thu Aug 21 2003
 * copyright    : (C) 2003 by Petr Tovarys
 */

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it according to instructions in massiv/doc/licenses/source.txt.       *
 *                                                                         *
 ***************************************************************************/

#ifndef DEMO_GAME_DEFS_H
#define DEMO_GAME_DEFS_H

namespace Demo {
namespace Lib {


/** Entity abilities and attributes. */
enum AbilityId
    {
    ABILITY_HEALTH  =   0,
    ABILITY_SPEED =     1,
    ABILITY_COUNT =     2
    }; // AbilityId

/** Item type. */
enum ItemType
    {
    ITEM_UNKNOWN =      0,
    ITEM_POTION =       1,    ///< Drinkable or eatable item.
    ITEM_GARBAGE =      2,    ///< Garbage.
    ITEM_BOOTS =        3,    ///< Boots.
    ITEM_WEAPON =       4,    ///< Weapon.
    }; // ItemType

/** Garbage type if item type is @c ITEM_GARBAGE. */
enum GarbageType
    {
    GARBAGE_FLASK =     0,
    GARBAGE_BONE =      1,
    }; // GarbageType

/** Potion type if item type is @c ITEM_POTION. */
enum PotionType
    {
    POTION_HEALTH =     0,
    POTION_SPEED =      1,
    POTION_MEAT =       2,
    }; // PotionType

/** Boots type if item type is @c ITEM_BOOTS. */
enum BootsType
    {
    BOOTS_SPEED =       0,
        /**< If equipped, adds extra speed. */
    }; // BootsType

/** Weapon type if item type is @c ITEM_WEAPON. */
enum WeaponType
    {
    WEAPON_AXE =        0,
    }; // WeaponType

/** Equip cathegories. */
enum EquipType
    {
    EQUIP_NONE =    0,
        /**< Item is not equipable. */
    EQUIP_BOOTS =   1
        /**< Item is equipable as boots. */
    }; // EquipType


} // namespace Demo::Lib
} // namespace Demo

#endif // DEMO_GAME_DEFS_H
