/** @file player_action.cpp
 * Player actions (implementation).
 */

/*
 * begin        : Tue Aug 5 2003
 * copyright    : (C) 2003 by Petr Tovarys
 */

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it according to instructions in massiv/doc/licenses/source.txt.       *
 *                                                                         *
 ***************************************************************************/


#include "core.h"
#include "lib/shared/player_action.h"


namespace Demo {
namespace Lib {


// PlayerMoveAction
//~~~~~~~~~~~~~~~~~

PlayerMoveAction::PlayerMoveAction()
    {
    initialize_object();
    }


PlayerMoveAction::PlayerMoveAction
    (
    const PlayerMoveAction & other
    ) : ValueType( other ),
        target_position( other.target_position )
    {
    initialize_object();
    }


// PlayerItemAction
//~~~~~~~~~~~~~~~~~

PlayerItemAction::PlayerItemAction()
    {
    initialize_object();
    }


PlayerItemAction::PlayerItemAction
    (
    const PlayerItemAction & other
    ) : ValueType( other ),
        source( other.source ),
        source_slot_index( other.source_slot_index ),
        source_object( other.source_object ),
        target( other.target ),
        target_slot_index( other.target_slot_index ),
        target_object( other.target_object ),
        target_position( other.target_position )
    {
    initialize_object();
    }


} // namespace Demo::Lib
} // namespace Demo
