/** @file random.cpp
 * Random implementation.
 */

/*
 * begin        : Mon Dec 1 2003
 * copyright    : (C) 2003 by Marek Vondrak
 */

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it according to instructions in massiv/doc/licenses/source.txt.       *
 *                                                                         *
 ***************************************************************************/


#include "core.h"
#include "lib/shared/random.h"


namespace Demo {
namespace Lib {

INJECT_CORE_SYMBOLS();


Float32 Random::random()
    {
    return std::rand() / static_cast<Float32>( RAND_MAX );
    }


unsigned Random::random_integer
    (
    unsigned max_value
    )
    {
    unsigned value = static_cast<unsigned>( std::rand() * static_cast<Float32>( 
        max_value ) / static_cast<Float32>( RAND_MAX ) );

    if( value > max_value )
        {
        value = max_value;
        }

    return value;
    }


SVector2 Random::random_vector()
    {
    return SVector2( 2.0f * random() - 1.0f, 2.0f * random() - 1.0f );
    }


} // namespace Demo::Lib
} // namespace Demo
