/** @file server_global.cpp
 * Global server stuff.
 */

/*
 * begin        : Oct 2003
 * copyright    : (C) 2003 by Ondrej Pecta
 */

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it according to instructions in massiv/doc/licenses/source.txt.       *
 *                                                                         *
 ***************************************************************************/

#include "core_base.h"
#include "server_global.h"
#include "lib/server/account_console.h"
#include <memory> // auto_ptr


namespace Demo {
namespace Server {


Global::Objects *    Global::objects = NULL;

void Global::initialize()
    {
    try
        {
        // Initialize the objects.

        objects = new Objects;
        objects->initialize();
        }
    catch( ... )
        {
        shutdown();
        throw;
        }
    }


void Global::shutdown()
    {
    delete objects;
    objects = NULL;
    }


Global::Objects::Objects()
    {
    // Note: Wa can't initialize media repository in this constructor
    // because Global::objects is NULL, so other objects are not able
    // to use the repository anywhere in this constructor.

    account_console.reset( new Demo::Lib::AccountConsole );
    }


Global::Objects::~Objects()
    {
    account_console.reset();
    }


void Global::Objects::initialize()
    {
    }


} // namespace Server
} // namespace Demo


#ifndef ENABLE_INLINE
#include "server_global_inline.h"
#endif
