/** @file main.cpp
 * Service executable entry point.
 */

/*
 * begin        : Tue Jun 2 2003
 * copyright    : (C) 2003 by Petr Tovarys
 */

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it according to instructions in massiv/doc/licenses/source.txt.       *
 *                                                                         *
 ***************************************************************************/


#include "service_main.h"
#include "status/exception.h"
#include <iostream>
#include <typeinfo>


/**
 * Main.
 */
int main
    (
    int             argc,
    const char **   argv
    )
    {
    try
        {
        Demo::Service::service_main( argc, argv );
        }
    catch( std::exception & exception )
        {
        std::cout << "Unhandled exception " << typeid( exception ).name() <<
            " caught:\n" << exception.what() << std::endl;
        }
    catch( ... )
        {
        std::cout << "Unhandled non-massiv exception." << std::endl;
        throw; // Let the runtime library show some info.
        }

    return 0;
    }
