/** @file
 * "Creating Managed Class" example.
 * Interface of the HelloInterface class.
 */

/*
 * begin        : Feb 2004
 * copyright    : (C) 2004 by Stepan Vondrak
 */

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it according to instructions in massiv/doc/licenses/source.txt.       *
 *                                                                         *
 ***************************************************************************/

/*LINE 1*/
/*BEGIN all*/
#ifndef EXAMPLE_HELLO_INTERFACE_H
#define EXAMPLE_HELLO_INTERFACE_H

/*BEGIN include*/
#ifndef MASSIV_CORE_H
#include "core.h"
#endif

#include <string>
/*END include*/

/*BEGIN namespace*/
namespace example {
/*END namespace*/
/*BEGIN class*/
/**
 * Interface of hello classes.
 *
 * This is generic interface of all classes that implement the
 * hello() method.
 *
 * As described in the IDL, all Hello classes should be root objects
 * of KIND_SERVER kind.
 */
class HelloInterface : public ::Massiv::Core::Object
    {
public:

    /**
     * The "say hello" method.
     *
     * It should generate a hello message for the callee @a callee_name,
     * print it anywhere it wants and return it.
     */
    virtual std::string hello
        (
        const std::string & callee_name
        ) = 0;

    }; // class HelloInterface
/*END class*/

} // namespace example

#endif // EXAMPLE_HELLO_INTERFACE_H
/*END all*/
