/** @file server_common.h
 * Common settings for server tests.
 */

/*
 * begin        : Wed Dec 18 2002
 * copyright    : (C) 2002 by Petr Tovarys
 */

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it according to instructions in massiv/doc/licenses/source.txt.       *
 *                                                                         *
 ***************************************************************************/


#ifndef _SERVER_COMMON_H_
#define _SERVER_COMMON_H_


#include "core.h"
#include <iostream>


namespace Massiv {
namespace ServerTest {


/**
 * Common settings for server tests.
 */
class ServerCommon
    {
public:

    /**
     * Server options.
     */
    class Options
        {
    public:
        /** Constructor. */
        Options();
        
    public:
    
        bool                    create_initial_archive;
            /**< Whether initial archive should be created. */
            
        Massiv::Core::UInt32    initial_provider_id;
            /**< Id of initial provider id.
             * Valid only if create_initial_archive is true.
             */

        bool                    enable_archivation;
            /**< Whether the server should perform archivation during simulation. */
            
        }; // Options
public:

    /**
     * Parse program's arguments.
     */
    static void init
        (
        int             argc,
        const char **   argv
        );

public:

    /**
     * Get options.
     */
    static const Options & options();

    }; // ServerCommon

} // namespace Massiv::ServerTest
} // namespace Massiv


#endif // _SERVER_COMMON_H_
