/** @file server_main.cpp
 * Testing server.
 */

/*
 * begin        : Tue Nov 19 2002
 * copyright    : (C) 2002 by Petr Tovarys
 */

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it according to instructions in massiv/doc/licenses/source.txt.       *
 *                                                                         *
 ***************************************************************************/


#include "server_main.h"
#include "server_common.h"
#include "core.h"
#include <iostream>
#include "thread/thread.h" // Thread::sleep()


using namespace Massiv::Core;


namespace Massiv {
namespace ServerTest {


static void register_classes()
    {
    }


static void create_node_object_callback()
    {
    }


static void next_tick_callback()
    {
    static SystemTime   old_time = System::system_time();
    
    if( 1 )
        {
        // Print num of seconds elapsed.
        SystemTime  curr_time = System::system_time();
        while( ( curr_time - old_time ) > 1 )
            {
            old_time += 1;
            std::cout << "[" << (int)( old_time.get_value() ) << "]" << std::endl;
            }
        Thread::sleep( 1 );
        }
    }


static void initialize()
    {
    unsigned int flags = 0;
    flags |= System::INIT_COUT_LOGGER_DESTINATION;
    flags |= System::INIT_STANDALONE_NODE;

    System::register_classes( &register_classes );
    System::register_create_node_object( &create_node_object_callback );
    System::register_next_tick( &next_tick_callback );

    System::initialize( flags );

    if( ( flags & System::INIT_STANDALONE_NODE ) != 0 )
        {
        std::cout   << "---------------------------"
                    << "RUNNING IN STANDALONE NODE!"
                    << "---------------------------"
                    << std::endl;
        }
    }


void server_main()
    {
    std::cout << "Initializing..." << std::endl;
    initialize();

    std::cout << "Connecting..." << std::endl;
    System::connect();
    
    std::cout << "Running..." << std::endl;
    System::run();
    
    std::cout << "Shutting down..." << std::endl;
    System::shutdown();
    }


} // namespace ServerTest
} // namespace Massiv
