/** @file signal_element.cpp
 * Base signal element classes implementation.
 */

/*
 * begin        : Thu Mar 11 2003
 * copyright    : (C) 2003 by Martin Havlista
 */

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it according to instructions in massiv/doc/licenses/source.txt.       *
 *                                                                         *
 ***************************************************************************/


#include "signal_element_base.h"
#include "signal_element_base_rpc.h"
#include "utility/debug.h"
#include <iostream>


namespace Massiv {
namespace ServerTest {
namespace Signal {


// class SignalElement

void SignalElement::signal
    (
    int     sig_num
    )
    {
    panic( "SignalElement cannot be instantiated." );
    }


// class SignalSendElement

SignalSendElement::SignalSendElement() :
    registered( false )
    {
    }


void SignalSendElement::signal
    (
    int     sig_num
    )
    {
    panic( "SignalSendElement cannot be instantiated." );
    }


void SignalSendElement::register_signalized_element
    (
    WeakPointer< SignalElement >    signalized_element
    )
    {
    sig_element = signalized_element.convert();
    registered = true;
    }


void SignalSendElement::signal_all
    (
    int     sig_num
    )
    {
    // @todo: zatim to posila signal pouze jednomu elementu
    sig_element->signal( sig_num );
    }


} // namespace Massiv::ServerTest::Signal
} // namespace Massiv::ServerTest
} // namespace Massiv
