/** @file objects.h
 * Testing objects.
 */

/*
 * begin        : Mon Oct 22 2002
 * copyright    : (C) 2002 by Stepan Vondrak
 */

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it according to instructions in massiv/doc/licenses/source.txt.       *
 *                                                                         *
 ***************************************************************************/

#ifndef _OBJECTS_H_
#define _OBJECTS_H_


#include "core.h"


using namespace Massiv::Core;


namespace Massiv {
namespace ServerTest {
namespace Startup {


/**
 * Plain object.
 */
class Null : public Object
    {
    NO_COPY_CONSTRUCTOR( Null );
    NO_ASSIGNMENT_OPERATOR( Null );

public:

    /**
     * Default constructor.
     */
    Null();

    /**
     * Destructor.
     */
    virtual ~Null();

    /**
     * Finalize Null.
     */
    virtual void finalize();

public:

    /**
     * Initializes object.
     */
    void initialize();

    }; // class Null


/**
 * GC root object.
 */
class Root : public Object
    {
    NO_COPY_CONSTRUCTOR( Root );
    NO_ASSIGNMENT_OPERATOR( Root );

public:

    /**
     * Default constructor.
     */
    Root();

    /**
     * Destructor.
     */
    virtual ~Root();

    /**
     * Finalize Root.
     */
    virtual void finalize();

    /**
     * Initializes object.
     */
    void initialize();

public:

    PPointer< Null > null;
        /**< Strong pointer to Null. */

    }; // class Root


} // namespace Massiv::ServerTest::Startup
} // namespace Massiv::ServerTest
} // namespace Massiv


#endif // _OBJECTS_H_
